# 5竞争机器学习的好处

> 原文： [https://machinelearningmastery.com/5-benefits-of-competitive-machine-learning/](https://machinelearningmastery.com/5-benefits-of-competitive-machine-learning/)

Jeremy Howard， [Kaggle](http://www.kaggle.com/) 的正式演出于2013年中期在[旧金山大学](http://www.usfca.edu/)进行了演示。在那次演讲中他谈到了机器学习比赛的一些更广泛的好处，比如那些Kaggle。

在这篇文章中，你将发现我从这次演讲中提取的5分，这将激励你想要开始参加机器学习比赛

[![Competitive Machine Learning is a Meritocracy](img/5dab5e85e1fd800e2906680bb1b7db51.jpg)](https://3qeqpr26caki16dnhd19sv6by6v-wpengine.netdna-ssl.com/wp-content/uploads/2014/08/Competitive-Machine-Learning-is-a-Meritocracy.jpg)

竞争机器学习是一种精英政治
摄影作者 [PaulBarber](https://www.flickr.com/photos/boipevassu/7742521640) ，保留一些权利

## 南佛罗里达大学的大数据

霍华德的演讲名为“ [_Kaggle的Jeremy Howard在旧金山大学_](https://www.youtube.com/watch?v=OKOlO9nIHUE) 讲述大数据。标题用词不当。这次演讲主要关注霍华德的背景，他是如何进行机器学习以及简单地谈论讨人喜欢的。

霍华德有一个初创企业的背景，这个讲话很好地总结了这一背景以及他必须从那次旅程中传授的教训。

&lt;iframe allowfullscreen="" frameborder="0" height="281" src="https://www.youtube.com/embed/OKOlO9nIHUE?feature=oembed" width="500"&gt;&lt;/iframe&gt;

在演讲结束时，霍华德接触了Kaggle及其使命，这是激发这5点的灵感。他们是：

1.  **Meritocracy** ：状态完全基于能力。
2.  **角色模型**：最佳表演者及其原创故事成为榜样。
3.  **推送限制**：排行榜推动您和群组的功能。
4.  **创新**：竞争导致技术创新。
5.  **社区**：像大脑一样找到对方并分享想法。

## 1.精英政治

数据科学或机器学习竞赛是一种精英。这意味着等级仅根据优点确定。

所给出的类比是体育运动，其中唯一重要的是运动员所取得的成果。无论你来自哪里，你的性别或你去哪里上学都没关系。重要的是你可以取得的成果。

这样的系统是公平的，像工作场所那样存在的偏差不会影响结果。该系统也是透明的，每个人都可以访问相同的源材料（训练数据）和表现评估（排行榜）。

我们在之前的帖子中已经触及过这个问题[应用机器学习是一个Meritocracy](http://machinelearningmastery.com/applied-machine-learning-is-a-meritocracy/ "Applied Machine Learning is a Meritocracy") 。

## 2.角色模型

比赛创造了榜样。

比赛的结果表明，通常不是学术上做得好，但那些具有适应性工程思维的人使用有效的方法来获得最好的结果。具有多样化和有趣背景的人在该平台上的所有数据科学家中排名前10位或前100名。

这具有创建角色模型的效果。他们的故事是不同的，例如一年前在免费的Coursera课程中遇到过机器学习。这些有趣的故事吸引你，“_，如果他能做到，我可以做到_”。

你还看到，当一位“知名”数据科学家加入竞争时，就像 [Netflix奖](http://en.wikipedia.org/wiki/Netflix_Prize)中的明星一样，这引起了更多的关注，“_我想打败做得好的人在Nextfix奖_中。

## 3.推限制

与体育一样，排行榜可以突破你和团队所能达到的极限。

只要知道一个人知道你所做的事情，即使你已经全部给了它，也可以推动你去寻找那一条额外的信息。

排行榜的实时反馈对可以实现的结果产生心理影响。这可能会像四分一英里那样削减两种方式，直到 [Roger Bannister打破它](http://en.wikipedia.org/wiki/Four-minute_mile)，证明它可以完成。

## 4.创新

竞争导致技术创新。

每次都会破坏最先进的基准测试。这种情况最有可能发生，因为问题已明确指定用于机器学习，并且因为参与者不限于在给定领域或研究领域中使用的方法。什么都可以。

这开辟了讨论问题的不同方式，既可以在现场利用，也可以利用未来类似的竞争，加速全面推进。

## 5.社区

社区围绕着竞争而兴起。

在分享信息方面存在平衡，但在分享竞争中失败的情况下不会分享太多信息。分享您和小组的好处，并且似乎在每场比赛中自动发生。

就像大脑一样，找到彼此并团结起来，利用彼此最好的部分想法，超越他们独立的能力。

社区和信息流是良好竞争的关键因素。它们帮助初学者入门，推动中间体的发展和创新。

## 摘要

在这篇文章中，您发现了竞争机器学习的五大好处。它们是：精英管理，榜样，推动极限，创新和社区。

这在机器学习方面并不新鲜，与学术会议合作已有近20年的竞争。新的是参与规模和进入门槛低。无论您的背景如何，这都是进入应用机器学习的激动人心的机会主义时刻。