# 如何开始使用Kaggle

> 原文： [https://machinelearningmastery.com/get-started-with-kaggle/](https://machinelearningmastery.com/get-started-with-kaggle/)

#### 入门和擅长
竞争机器学习的四步流程。

[Kaggle](https://www.kaggle.com/) 是一个托管机器学习竞赛的社区和网站。

有竞争力的机器学习可以成为开发和练习技能的好方法，也可以展示您的能力。

在这篇文章中，您将发现一个简单的4步骤过程，以便在Kaggle上进行有竞争力的机器学习。

让我们开始吧。

![How to Get Started with Kaggle](https://3qeqpr26caki16dnhd19sv6by6v-wpengine.netdna-ssl.com/wp-content/uploads/2017/03/How-to-Get-Started-with-Kaggle.jpg)

如何开始使用Kaggle
照片由 [David Mulder](https://www.flickr.com/photos/113026679@N03/14207581423/) 拍摄，保留一些权利。

## 关于Kaggle的建议？

我通过电子邮件询问了很多问题：

> 我如何开始使用Kaggle？

我对这个问题做了最后的回答，并决定把它变成这篇博文。我希望你发现它很有用。

希望对你有帮助。

## 为什么Kaggle？

有许多方法可以学习和练习应用机器学习。

Kaggle有一些特别的好处，你应该认真考虑：

*   问题已明确定义，所有可用数据均直接提供。
*   考虑到公共和私人排行榜的严酷事实，用一个糟糕的测试设置来欺骗自己更难。
*   每个比赛都经常进行很好的讨论和分享，您可以从中学习并为此做出贡献。
*   您可以在可以展示您的技能的困难的真实世界数据集上构建项目组合。
*   这是一个完整的精英管理，提供能力和技能是决定因素，而不是你去学校的地方，你知道的数学，或你有多少学位。

## 概观

我推荐一个简单的4步骤过程。步骤是：

1.  选择一个平台。
2.  练习标准数据集。
3.  练习旧的Kaggle问题。
4.  在Kaggle上竞争。

该过程易于描述，但难以实施。这需要时间和精力。这将是艰苦的工作。

但…

它会得到回报，如果你有条不紊并且坚持下去，你将成为世界级的机器学习从业者。

你可以直接进入第4步，这可能适合你，但我设计了这个过程，以最大限度地提高你坚持下去并获得高于平均水平的结果。

让我们更详细地看一下每一步。

## 1.选择一个平台

有许多机器学习平台可供选择，你最终可能会使用其中许多，但从一开始。

我推荐Python。

为什么？

*   对Python机器学习技能的需求正在增长。
*   Python是一种功能齐全的编程语言（与R不同）。
*   生态系统已经足够成熟（sklearn，pandas，statsmodels，xgboost等）
*   该平台拥有一些最好的深度学习工具（theano，tensorflow，keras）

选择一个平台并开始学习如何使用它。

这里有一些进一步的阅读：

*   [Python是应用机器学习的增长平台](http://machinelearningmastery.com/python-growing-platform-applied-machine-learning/)
*   [Python机器学习](http://machinelearningmastery.com/start-here/#python)

## 2.标准数据集的实践

选择平台后，您需要非常擅长在真实数据集上使用它。

我建议在UCI机器学习库或类似工具上完成一套标准的机器学习问题。

将每个数据集视为迷你竞争对手。

*   将其拆分为训练并保留测试集，将测试集拆分为公共和私人排行榜集。
*   概述了处理每个数据集的过程，坚持下去，添加到该数据集，直到您可以轻松获得要处理的任何小数据集的最佳结果。
*   将每个数据集的时间框设置为一个或几个小时。
*   利用数据集上和与数据集相关的出版物来帮助更好地定义给定问题并解释这些特征。
*   了解如何充分利用工具，算法以及数据集。

把这部分想象成演习。好起来

将项目作为项目组合的一部分，以利用您处理的每个新项目。

这里有一些进一步的阅读：

*   [使用小型内存数据集练习机器学习](http://machinelearningmastery.com/practice-machine-learning-with-small-in-memory-datasets-from-the-uci-machine-learning-repository/)
*   [应用机器学习过程](http://machinelearningmastery.com/start-here/#process)

## 3.练习旧的Kaggle问题

现在您已经了解了工具以及如何使用它们，现在是时候练习旧的Kaggle数据集了。

您可以访问过去Kaggle比赛的数据集。您还可以发布候选解决方案，并在公共和私人排行榜上对其进行评估。

我建议在过去的几年中解决一系列Kaggle问题。

此步骤旨在帮助您了解最佳表现者如何处理竞争机器学习并学习如何将他们的方法集成到您的流程中。

*   选择各种不同的问题类型，迫使您学习和应用新的和不同的技术。
*   研究论坛帖子，获胜者写作博客文章，GitHub存储库以及问题的所有其他信息，并将这些方法合并到您的流程中。
*   目标是在公共或私人排行榜中获得前10％或更高的分数。
*   尝试将尽可能多的获胜者方法纳入您的候选解决方案。

把它想象成先进的钻头。善于像竞争获胜者一样思考并使用他们的方法和工具。

再次，将每个已完成的项目添加到您的投资组合中，以利用未来的项

这里有一些进一步的阅读：

*   [机器学习是讨价还价的竞赛](http://machinelearningmastery.com/machine-learning-is-kaggle-competitions/)
*   [发现Kaggle Master的方法论和心态：对Diogo Ferreira的采访](http://machinelearningmastery.com/discover-the-methodology-and-mindset-of-a-kaggle-master-an-interview-with-diogo-ferreira/)

## 4.在Kaggle上竞争

你现在准备在Kaggle上竞争了。

得到它。

*   考虑一次处理一个问题，直到你出现问题或陷入困境。
*   旨在为您所处理的每个竞赛在私人排行榜上取得前25％或前10％的成绩。
*   在论坛上自由分享;这将导致合作。
*   最大限度地缩短阅读或思考好主意与实施之间的时间（例如分钟）。

玩得开心。

他们可能是比赛，但你参与学习和分享。

这里有一些进一步的阅读：

*   [如何在竞争机器学习中踢屁](http://machinelearningmastery.com/how-to-kick-ass-in-competitive-machine-learning/)
*   [Master Kaggle一直竞争](http://machinelearningmastery.com/master-kaggle-by-competing-consistently/)

## 摘要

在这篇文章中，您发现了一个简单的4步过程，用于开始并在Kaggle上进行有竞争力的机器学习。

你参加过Kaggle比赛吗？
你是怎么开始的？

你决定按照这个过程吗？
你好吗？