# 线性代数评论没有废话指南

> 原文： [https://machinelearningmastery.com/no-bullshit-guide-to-linear-algebra-review/](https://machinelearningmastery.com/no-bullshit-guide-to-linear-algebra-review/)

有许多书籍介绍了线性代数领域。

大多数是针对本科生的教科书，并且充满了几乎没有相关性的理论偏见，并且大多分散了初学者或实践者对该领域的注意力。

在这篇文章中，您将发现“[无线性代数的废话指南](http://www.amazon.com/dp/0992001021?tag=inspiredalgor-20)”这本书，它简单介绍了线性代数领域，并假设没有先前的数学知识。

阅读这篇文章后，你会知道：

*   关于本书对初学者或从业者的目标和好处。
*   本章内容和每章介绍的一般主题。
*   一个选定的阅读列表，针对希望快速加速的机器学习从业者。

让我们开始吧。

![No Bullshit Guide To Linear Algebra Review](img/47d688f5a73ba57fef3bf269190866bf.jpg)

没有废话指南线性代数评论
照片由 [Ralf Kayser](https://www.flickr.com/photos/ralky/7233272960/) ，保留一些权利。

## 图书概述

该书提供了线性代数的介绍，可与本科大学课程相媲美。

这本书的关键方法是没有废话，直截了当。这意味着激光专注于给定的操作或技术，没有（或很少）绕道或离题。

这本书是由 Ivan Savov 编写的，第二版于 2017 年发布.Ivan 拥有电气工程学士学位和硕士和博士学位。在物理学方面，他作为数学和物理学的私人导师在过去的 15 年里一直工作。他知道这个主题以及学生遇到困难的地方。

[![Amazon Image](img/6d7cdfac767aacc713fa2457b5d6d258.jpg)](http://www.amazon.com/dp/0992001021?tag=inspiredalgor-20)

### 没有先决条件数学

这本书对于机器学习从业者来说是一本很好的书是因为这本书是独立的。它没有假设任何先前的数学背景，所有先决条件数学，这是最小的，在第一章标题为“_ 数学基础 _”中有所介绍。

如果你从未学过线性代数，或者你几十年前在学校学过它并且几乎忘记了一切，那么它是完美的书。

### 练习练习

使本书适合机器学习从业者的另一个方面是它包括练习。

每个部分都以一些 pop-quiz 样式问题结束。

每章最后都有一个问题集供您使用。

最后，附录 A 提供了本书中所有练习的答案。

## 目录

本节提供了本书目录的摘要。

1.  **数学基础**。涵盖了开始学习线性代数所需的必备数学主题。主题包括数字，函数，三角函数，复数和集合表示法。
2.  **线性代数**简介。向量和矩阵代数的介绍，是线性代数的基础。主题包括向量和矩阵运算和线性。
3.  **计算线性代数**。本章介绍了在开始实现线性代数时遇到的问题，并且必须以任何规模处理操作。主题包括矩阵方程，矩阵乘法和行列式。给出了一些 Python 示例。
4.  **线性代数的几何方面**。涵盖了向量代数的几何直觉，这是很常见的。主题包括直线和平面，投影和向量空间。
5.  **线性变换**。涵盖线性代数的核心光纤，正如 Ivan 所描述的那样。介绍线性变换。
6.  **理论线性代数**。在应用之前涵盖矩阵代数的最后几步。涵盖了矩阵分解方法，矩阵类型等主题。
7.  **申请**。本章介绍了线性代数应用于电子，图形，计算机图形等各种领域的令人印象深刻的列表。令人印象深刻的一章让整本书中学到的方法具体化。
8.  **概率论**。在包括马尔可夫链和 PageRank 算法的线性代数的背景下提供概率论的速成课程。
9.  **量子力学**。通过线性代数的镜头提供量子力学的速成课程，线性代数是作者的专业领域。

## 机器学习从业者的选择

这本书很棒，如果你真的喜欢它，我建议你从封面到封面阅读。

但是，作为机器学习从业者，您不需要全部阅读。

以下是我建议快速获得线性代数的书中所选阅读的列表：

*   **概念图**。页面 v。在目录之后直接提供了思维导图类型图的集合，其中显示了书中的概念，以及实际上线性代数领域中的概念。如果您是视觉思考者，这些可能有助于将各个部分组合在一起。
*   第 1.15 节，**载体**。在任何向量代数之前，简要介绍向量。有用的背景。
*   第 2 章，**线性代数简介**。第 101-130 页。阅读整章。它涵盖：
    *   线性代数中术语的定义。
    *   向量运算，如算术运算和向量范数。
    *   矩阵运算，如算术运算和点积运算。
    *   线性以及这个关键概念究竟在线性代数中意味着什么
    *   线性代数（几何，理论等）的不同方面如何相关的概述。
*   第 3.2 节**矩阵方程**。第 147.页包括用于计算矩阵运算的解释和清晰图表，尤其是必须知道的矩阵乘法
*   第 6.1 节**特征值和特征向量**。第 262 页。介绍特征分解，该特征分解用作主成分分析等方法中的关键操作。
*   第 6.2 节**特殊类型的矩阵**。第 275 页介绍了各种不同类型的矩阵，如对角线，对称，正交等。
*   第 6.6 节**矩阵分解**。引入矩阵分解方法，重新覆盖特征分解，但也包括 LU，QR 和奇异值分解。
*   第 7.7 节**最小二乘近似解**。第 241 页。最小二乘矩阵公式的介绍，称为线性最小二乘法。
*   附录 B，**表示法**。数学和线性代数符号的摘要。

## 进一步阅读

如果您希望深入了解，本节将提供有关该主题的更多资源。

*   [亚马逊上的线性代数没有废话指南](http://amzn.to/2k76D4C)
*   [Mini Reference Publisher 主页](https://minireference.com/)
*   [推特上的 Ivan Savov](https://twitter.com/mcgillweb)
*   [线性代数在四页](https://minireference.com/blog/linear-algebra-tutorial/)，2013 中进行了解释。

## 摘要

在这篇文章中，您发现了一本书“线性代数的无废话指南”，该书提供了对线性代数领域的温和介绍，并假设没有先前的数学知识。

具体来说，你学到了：

*   关于本书对初学者或从业者的目标和好处。
*   本章内容和每章介绍的一般主题。
*   一个选定的阅读列表，针对希望快速加速的机器学习从业者。

你读过这本书吗？你觉得呢？
请在下面的评论中告诉我。

你有任何问题吗？
在下面的评论中提出您的问题，我会尽力回答。