# 机器学习算法如何工作（他们学习输入到输出的映射）

> 原文： [https://machinelearningmastery.com/how-machine-learning-algorithms-work/](https://machinelearningmastery.com/how-machine-learning-algorithms-work/)

机器学习算法如何工作？

有一个共同的原则是所有监督机器学习算法的基础，用于预测建模。

在这篇文章中，您将通过理解作为所有算法基础的共同原则来发现机器学习算法如何实际工作。

![How Machine Learning Algorithms Work](img/0fc451f9ec128c544f0f6a0e52ee6884.jpg)

机器学习算法如何工作
照片来自 [GotCredit](https://www.flickr.com/photos/jakerust/16846023595/) ，保留一些权利。

让我们开始吧。

## 学习功能

机器学习算法被描述为学习目标函数（f），其最佳地将输入变量（X）映射到输出变量（Y）。

Y = f（X）

这是一个通用的学习任务，我们希望在未来（Y）中给出预测输入变量（X）的新例子。

我们不知道函数（f）的外观或形式。如果我们这样做，我们将直接使用它，我们不需要使用机器学习算法从数据中学习它。

这比你想象的要难。还存在与输入数据（X）无关的错误（e）。

Y = f（X）+ e

此错误可能是错误，例如没有足够的属性来充分表征从X到Y的最佳映射。此错误称为不可减少的错误，因为无论我们在估计目标函数（f）方面有多好，我们都无法减少此错误。

这就是说，从数据中学习函数的问题是一个难题，这就是机器学习和机器学习算法领域存在的原因。

## 获取免费算法思维导图

![Machine Learning Algorithms Mind Map](img/2ce1275c2a1cac30a9f4eea6edd42d61.jpg)

方便的机器学习算法思维导图的样本。

我已经创建了一个由类型组织的60多种算法的方便思维导图。

下载，打印并使用它。

## 学习一种功能来做出预测

最常见的机器学习类型是学习映射Y = f（X）来预测新X的Y.

这称为预测建模或预测分析，我们的目标是使最准确的预测成为可能。

因此，我们并不真正感兴趣的是我们正在学习的函数（f）的形状和形式，只是它能够做出准确的预测。

我们可以学习Y = f（X）的映射，以更多地了解数据中的关系，这称为统计推断。如果这是目标，我们将使用更简单的方法和价值理解上面（f）的学习模型和形式进行准确的预测。

当我们学习函数（f）时，我们从我们可用的数据中估计它的形式。因此，此估计将有错误。它不是对给定X的Y的基本假设最佳映射的完美估计。

在应用机器学习中花费大量时间来尝试改进基础功能的估计并且在术语上改进模型所做出的预测的表现。

## 学习函数的技巧

机器学习算法是用于估计目标函数（f）以在给定输入变量（X）的情况下预测输出变量（Y）的技术。

不同的表示对所学习的函数的形式做出不同的假设，例如它是线性的还是非线性的。

不同的机器学习算法对函数的形状和结构做出不同的假设，以及如何最好地优化表示以近似它。

这就是为什么在机器学习问题上尝试一套不同的算法非常重要的原因，因为我们无法事先知道哪种方法最适合估计我们试图近似的基础函数的结构。

## 摘要

在这篇文章中，您发现了解释所有机器学习算法用于预测建模的目标的基本原理。

您了解到机器学习算法可以在给定输入变量（X）或Y = f（X）的情况下估算输出变量（Y）的映射函数（f）。

您还了解到，不同的机器学习算法对基础函数的形式做出了不同的假设。当我们对目标函数的形式知之甚少时，我们必须尝试一套不同的算法来看看哪种方法效果最好。

您对机器学习算法或此帖子有何疑问？发表评论并提出您的问题，我会尽力回答。