# 你应该培养的 5 个机器学习领域

> 原文： [https://machinelearningmastery.com/5-machine-learning-areas-you-should-be-cultivating/](https://machinelearningmastery.com/5-machine-learning-areas-you-should-be-cultivating/)

您希望学习机器学习以获得更多工作机会或找到工作。您可能已经在担任数据科学家或机器学习工程师，并希望提高您的技能。

它很容易掌握机器学习技能，因为它是编程技巧（你做不到）。

从数据分析类型工作到完整系统架构和集成，需要一些从事数据挖掘和机器学习的技能。

然而，您可能希望开发一些常见任务和常用技能，就像您可以为有抱负的软件开发人员所建议的那样。

在这篇文章中，我们将看看您可能想要开发技能的 5 个关键领域以及您可以在这些领域进行练习的活动类型。

[![machine learning skills](img/41caf2696650fba58bae008a5552f909.jpg)](https://3qeqpr26caki16dnhd19sv6by6v-wpengine.netdna-ssl.com/wp-content/uploads/2014/10/machine-learning-skills.jpg)

培养您的机器学习技能摄影： [Rachel Johnson](http://www.flickr.com/photos/rachel-johnson/4298911131) ，保留一些权利

## 1.机器学习基础和理论

你需要了解基础知识。这包括[定义](http://machinelearningmastery.com/what-is-machine-learning/ "What is Machine Learning: A Tour of Authoritative Definitions and a Handy One-Liner You Can Use")和[核心原则](http://machinelearningmastery.com/data-learning-and-modeling/ "Data, Learning and Modeling")。

您应该知道有监督和无监督的学习是什么以及每个的例子。你应该知道什么是过度学习和学习不足。

您还应该知道[估计预测模型对未见数据的表现](http://machinelearningmastery.com/how-to-evaluate-machine-learning-algorithms/ "How to Evaluate Machine Learning Algorithms")，[这样做的常用方法](http://machinelearningmastery.com/how-to-choose-the-right-test-options-when-evaluating-machine-learning-algorithms/ "How To Choose The Right Test Options When Evaluating Machine Learning Algorithms")和常见问题的重要性。

您还需要了解一些理论基础，包括使用概率论，线性代数和信息理论熟悉符号和算法描述。

您可能需要阅读一些介绍性书籍，或者一些教科书的介绍部分。轻松并继续将您学到的知识与您感兴趣的实际问题或数据集联系起来。

## 2.机器学习算法

您需要了解机器学习算法。

你可以挥挥手臂并评论这个算法对这种情况有好处，但大部分都是垃圾。 [通过大量的算法和算法参数的经验测试](http://machinelearningmastery.com/a-data-driven-approach-to-machine-learning/ "A Data-Driven Approach to Machine Learning")找到了良好的结果。

您可以和应该学习的是[那里有哪些算法](http://machinelearningmastery.com/a-tour-of-machine-learning-algorithms/ "A Tour of Machine Learning Algorithms")，一般类，以及它们如何工作。

阅读，研究甚至[从多个应用和理论来源构建您自己的算法描述](http://machinelearningmastery.com/how-to-learn-a-machine-learning-algorithm/ "How to Learn a Machine Learning Algorithm")。

[从头开始实现算法](http://machinelearningmastery.com/tutorial-to-implement-k-nearest-neighbors-in-python-from-scratch/ "Tutorial To Implement k-Nearest Neighbors in Python From Scratch")，以熟悉任何给定的算法实现必须使用的无数微决策。

试验算法。研究他们的行为以及他们的参数对他们的影响，并在多个标准问题实例中进行推广。

## 3.机器学习工具

您需要能够完成任务，这需要工具。

每次需要时，你都无法从最初的原则中实现一切。这是荒谬的。

您必须了解哪些工具，可以使用的以及何时使用它们。

学习一些机器学习工具和库，在标准数据集和竞赛中使用它们。了解他们的功能。了解它们提供的算法以及这些实现的怪癖。

我推荐至少 [Weka](http://machinelearningmastery.com/how-to-run-your-first-classifier-in-weka/ "How to Run Your First Classifier in Weka") ， [scikit-learn](http://machinelearningmastery.com/a-gentle-introduction-to-scikit-learn-a-python-machine-learning-library/ "A Gentle Introduction to Scikit-Learn: A Python Machine Learning Library") 和 [R](http://machinelearningmastery.com/what-is-r/ "What is R") 。我有很多关于秘籍的博客文章，只是搜索。

## 4.机器学习问题

机器学习算法的兄弟是[问题](http://machinelearningmastery.com/practical-machine-learning-problems/ "Practical Machine Learning Problems")。他们是双胞胎，不能分开。

你必须学习机器学习问题。这包括[案例研究](http://machinelearningmastery.com/discover-the-methodology-and-mindset-of-a-kaggle-master-an-interview-with-diogo-ferreira/ "Discover the Methodology and Mindset of a Kaggle Master: An Interview with Diogo Ferreira")，例如竞赛和论文的结果。

它还严格地包括如何解决问题。 [机器学习问题解决过程](http://machinelearningmastery.com/process-for-working-through-machine-learning-problems/ "Process for working through Machine Learning Problems")。如何从描述到呈现结果端到端地解决问题。

此外，您在此过程中使用了哪些工具，以及如何将结果从一个步骤转到下一个步骤。每个步骤成功的标准是什么。

如果你来自工程背景而不是算法变得容易，另一方面解决问题需要学习和努力工作。你必须成为科学家，制定并客观地检验假设。

编程不需要这种技能（好的，故障查找将是一个例外）。

## 5.保持最新状态

你必须保持最新状态。

当然这意味着要进行一些深度学习，因为这是一个热门的时尚。它很有可能在您遇到的那个难题上提供最先进的结果。

它还意味着随时了解新闻，开发工具（更改日志，会议等），理论和算法（研究论文，博客，会议视频等）。

技术变化很快，这是高科技。它变化得更快。期待并培养这种变化。

## 摘要

这是一篇短文，但我认为很重要。

我们触及了您应该培养的 5 个机器学习领域，以实现您在该领域的目标。

这五个领域又是：

1.  **机器学习基础和理论**：为定义，术语，原理和理论奠定坚实的基础。
2.  **机器学习算法**：读取和研究算法，从头开始实现算法并对它们进行实验，以便为它们的工作方式和原因建立直觉。
3.  **机器学习工具**：在愤怒中学习和使用机器学习工具和库，以有效利用您的时间。
4.  **机器学习问题**：研究问题案例研究，并不断研究应用机器学习的过程（或 KDD 或任何你想称之为的）。
5.  **保持最新**：让自己了解算法，问题工具甚至炒作的最新动态。期待一切都继续前进。

你不能一次完成所有这一切，选择一个区域并花一些时间，然后更改它。

您目前正在培养这五个领域中的哪一个？