# 通过提供结果在机器学习中获得梦想的工作

> 原文： [https://machinelearningmastery.com/get-dream-job-machine-learning-delivering-results/](https://machinelearningmastery.com/get-dream-job-machine-learning-delivering-results/)

你可以站起来，成为一名机器学习从业者和数据科学家。

你必须努力工作，学习技能并证明你可以提供成果，但你不需要花哨的学位或花哨的背景。

在这篇文章中，我想证明这是可能的，甚至是常见的。

你会发现，高层管理人员和首席执行官都在关注结果，而不是背景，而像你这样的程序员和工程师正在崛起，赢得比赛并从事机器学习。

[![Get Your Dream Job](img/29de6e3144fae1c04015b654e89c6f22.jpg)](https://3qeqpr26caki16dnhd19sv6by6v-wpengine.netdna-ssl.com/wp-content/uploads/2014/11/Get-Your-Dream-Job.jpg)

得到你梦想的工作
照片由 [Andrew Turner](http://www.flickr.com/photos/ajturner/3362409021) 拍摄，保留一些权利

## 结果特朗普背景

你去哪所学校，你可能拥有或不拥有什么学位，或者你曾经在哪些公司工作并不重要。

机器学习是一种精英。您可以提供的结果定义您的价值。

在 Fastcolabs 的一篇名为“ [DIY 数据科学家的崛起](http://www.fastcolabs.com/3014018/the-rise-of-the-diy-data-scientist)”的一篇文章中，当时的 Kaggle 总裁杰里米·霍华德明确表示结果很重要，而不是你的背景。他帮助：

> 赢得比赛的人通常不是斯坦福大学教育或常春藤联盟美国数学家。世界上最好的数据科学家根据他们的实际表现没有去过着名的学校。

如果您雇佣的是数据科学家，则应根据他们提供结果的能力对其进行评估。霍华德续说：

> 如果你想为你的马戏团聘请一个玩杂耍的人，你会让他玩杂耍，看看他能玩多少东西。如果您打算雇用某人来创建预测模型，请查看他们的模型预测的预测程度。

如果您在进入机器学习领域时注重结果，那么您可以取得惊人的快速进步。

在 2012 年的 Gigaom 帖子中标题为“[为什么成为一名数据科学家可能比你想象的更容易](https://gigaom.com/2012/10/14/why-becoming-a-data-scientist-might-be-easier-than-you-think/)”然后引用斯坦福教授和 Coursera 联合创始人 Andrew Ng 的话说：

> 机器学习已经成熟到了这一点，如果你上一门课，你实际上可以很好地应用它。

在同一篇文章中，作者指出当时有多少顶级 Kaggle 竞争对手除了免费在线课程之外几乎没有接受过任何训练。

在最近的一个例子中，Henk van Veen（称为 Triskelion）[通过持续参与机器学习并专注于方法，工具，展示了他如何在一年之内从谦逊的程序员转到](http://machinelearningmastery.com/master-kaggle-by-competing-consistently/ "Master Kaggle By Competing Consistently") [Kaggle 大师](http://machinelearningmastery.com/master-kaggle-by-competing-consistently/ "Master Kaggle By Competing Consistently")和提供结果的技术。

在他的帖子“[反思一年的 Kaggle 比赛](http://mlwave.com/reflecting-back-on-one-year-of-kaggle-contests/)”中他评论道：

> 我成了 Kaggle Master，主要是通过合奏学习，团队合作，分享，强大的 ML 工具和大数法则。

## 业余爱好者击败专家

您不需要成为某个领域的专家就可以在该领域创建有用且准确的预测模型。

事实上，如果目标是创建有用且准确的预测模型，那么专家知识可能是一个障碍而不是帮助。

杰里米·霍华德在接受新科学家（在 Slate 上重新发表）题为“[专家知识无用且无用](http://www.slate.com/articles/health_and_science/new_scientist/2012/12/kaggle_president_jeremy_howard_amateurs_beat_specialists_in_data_prediction.html)”的采访时表示：

> 你几十年的专业知识不仅没用，它们实际上是无益的;你的复杂技术比通用方法更差。

Kaggle 在特定的特定和业务领域举行比赛，观察可重复性是业余爱好者击败专家。

精通特定领域的专家进来并使用他们的传统。专家们通常不会赢得比赛。来自专用域的经典方法不执行。正是创造性和好奇的数据科学家击败了专家。

霍华德续说：

> 我们发现，创造性数据科学家可以比这些领域的专家更好地解决每个领域的问题。 ......那些能够看到数据实际告诉他们的人，而不会受到行业假设或专业知识的干扰。

## 结果不是学位

获得结果比你拥有的学位更重要。

这在编程中已经存在了很长时间，并且适用于应用机器学习。如果您能够有效地分析问题并设计和交付解决方案，那么您将非常有用且有价值。

在上一篇文章中，我谈到了[学位如何是一个捷径，其他人可以使用](http://machinelearningmastery.com/what-if-i-dont-have-a-degree/ "What if I Don’t Have a Degree")评估你的能力。您也可以通过其他方式构建这些快捷凭证，例如[构建机器学习项目组合](http://machinelearningmastery.com/build-a-machine-learning-portfolio/ "Build a Machine Learning Portfolio: Complete Small Focused Projects and Demonstrate Your Skills")。

这种投资组合方法正是艺术家使用的方法，也是程序员在没有经过正式训练的情况下获得有趣和高薪工作的方法。

正在寻找和雇用数据科学家和机器学习从业者的经理们正在寻找候选人的工作组合而不是学位。

在最近发布的一本书“[数据分析手册：CEO＆amp;经理](http://machinelearningmastery.com/the-data-analytics-handbook-ceos-and-managers/ "The Data Analytics Handbook: CEOs and Managers")“来自 Cloudera，Y-Hat，HG Data，Stylitics 等公司的首席执行官们接受了采访。他们被问及在招聘时他们在候选人中寻找什么，他们答案中的共同主题是他们看待候选人完成的项目。

这个主题也得到了本书作者的认可，并被强调为所有访谈中的前五名之一：Top Takeaway 3：**做自己的项目打入行业**

> 学术界和工业界之间存在学习差距，最好通过项目来填补。查找一些体育统计数据并进行自己的分析。学习 R 以便您可以完成此分析，而不仅仅是学习 R 本身。还试试 Kaggle。

Mode Analytics 的首席执行官兼联合创始人 Derek Steer 表示，在应用环境中构建模型并解决问题是最好的学习方法。

> 我认为学习技能的最佳方式是让你可以在将来实际应用它们，这是从一个项目开始，然后学习完成它所需的所有技能。

Smarter Remarketer 的联合创始人 Dean Abbott 对此表示赞同。

> ......开始建模。从事项目工作。它有助于与之前完成它的人合作。数据准备更难教，因为有很多方法可以让你错误地完成它。很难以一种涵盖所有“不正确”方法的方式进行教学

Stylitics 的首席执行官兼联合创始人 Rohan Deuskar 使用这种方法来评估求职者，他们必须完成一个项目以考虑工作。

> 我们还将为他们提供一个原始数据集，让他们分享他们在数据中看到的五个有趣的东西。他们还会被要求在几张 PowerPoint 幻灯片中展示他们的发现，因为根据我的部分数据分析师角色能够将您的发现传达给那些没有花时间在数据上的人。

最后，Cloudera 的高级课程开发人员 Tom Wheeler 推动了这一点，无论你的学习成绩如何还是缺乏，创造力和学习能力都能定义出令人惊叹的数据科学家：

> 就像有许多令人惊叹的程序员没有计算机科学博士学位一样，那些在这些领域获得硕士或学士学位后开始工作的数据科学家也是如此。如果他们具有好奇的个性和很多自我激励，他们往往可以通过现实世界的经验迅速获得他们所需的任何其他技能。

## 摘要

在这篇文章中，您发现结果可以胜过背景。如果您专注于获得结果的工具和方法，您可以快速学习机器学习，甚至成为 Kaggle 大师。

您发现业余爱好者通过专注于结果和培养建立预测模型的一般技能，在自己的游戏中击败专家。

最后，您了解到经理和 CEO 希望能够完成项目并使用项目来学习和展示技能，以评估分析师或数据科学家的技能。

您可以从这篇文章中汲取的教训是关注和发展您的韧性，执行速度和创造力。

放手需要成为领域专家，专注于提供成果。

放开您对花式学位的需求，开发[项目组合](http://machinelearningmastery.com/build-a-machine-learning-portfolio/ "Build a Machine Learning Portfolio: Complete Small Focused Projects and Demonstrate Your Skills")来展示您的技能。