# 使用小型目标项目深入了解机器学习工具

> 原文： [https://machinelearningmastery.com/investigate-machine-learning-tools/](https://machinelearningmastery.com/investigate-machine-learning-tools/)

选择机器学习工具后，您需要提高使用它的技能。

机器学习工具具有大量功能。拥有使用功能的方法与深入了解如何使用功能，其局限性或功能不同。

此外，一旦您在机器学习工具中建立技能，您需要能够证明您知道如何使用它。这不仅仅是在项目中使用它来提供结果。这有所帮助，但有一些方法可以在您构建知识时展示对工具的深入了解。

在这篇文章中，您将了解如何调查机器学习工具的功能，以便使用该工具提高您的技能并向其他人展示您不断增长的技能。在新项目开始和采访中，这对您最有帮助。

![Investigate Machine Learning Tools](img/f37617ecb2aee181821713f4db46b41d.jpg)

调查机器学习工具
照片由 [paurian](https://www.flickr.com/photos/paurian/3550755709/) ，保留一些权利。

## 培养机器学习工具的技能

一旦您选择或正在使用机器学习工具，您需要提高使用它的技能。当您在项目中使用该工具时，这会很自然，但它会缓慢，狭窄且无法控制。

您需要系统地提高您的机器学习工具功能的技能。

## 展示你不断增长的技能

当你正在建立自己的技能时，你可以谈论自己的表现如何，以及你变得多么熟练。这比实际显示您使用该工具获得的结果的影响小得多。同样，您可以指出您在项目上取得的成果，但这对大型项目来说可能非常缓慢，如果项目关闭则会令人沮丧。

您需要能够使用独立于您可能正在进行的项目的机器学习工具来展示您的技能。

## 工具特征的简短调查

您可以使用的策略是系统地调查所选机器学习工具的功能。

系统调查是一个简短的重点项目，它使用机器学习工具的特征来提供在应用机器学习[过程中有用的结果](http://machinelearningmastery.com/machine-learning-checklist/)。

这是一项您设计并完全控制的调查。

这也是一项调查，您拥有并可以分享其结果。您可以将其转换为视频，博客文章，开源项目或技术报告，以通过机器学习工具展示您不断增长的技能。

您可以使用特定的逐步过程来研究机器学习工具的功能。

## 调查机器学习工具

您可以使用系统过程来研究机器学习工具。

### 快速 5 步流程

1.  **选择工具**。选择要调查的工具。这可能是您列出的工具，您描述的工具或您已经程序化的工具。它可能是您已经使用的工具，您希望了解更多信息或更好地使用它。
2.  **选择一个功能**。选择要调查的工具的功能。理想情况下，这将是一个涵盖应用机器学习 [](http://machinelearningmastery.com/machine-learning-checklist/) [过程中的子任务的功能。这将是在对机器学习问题进行准确预测的过程中有用的特征。它应该有明确的输入和结果。](http://machinelearningmastery.com/machine-learning-checklist/)
3.  **研究特色**。研究如何在该工具的文档中使用该功能。这可能是 API 文档，教程，书籍和网站。了解该功能的属性以及如何以一种或多种方式使用它。
4.  **使用数据集**上的功能。在数据集上应用该功能。这可能是您自己的数据集，来自竞争机器学习的数据集或来自 UCI 机器学习库的标准研究数据集。使用该功能可以获得数据集的结果。例如，如果要素是数据分析技术，则执行分析，或创建模型，如果要素是预测模型，则进行预测。演示该功能可以提供的功能，限制和结果。
5.  **分享结果**。与朋友，同事或公开分享您获得的结果。您可以创建一个演示该工具功能的视频。或者，您可以创建有关如何使用数据集上的工具功能获得结果的分步教程。分享您的代码，程序和结果。

### 分享您的结果

不要忽视共享的最后一个重要步骤。

*   分享有助于您专注。
*   分享有助于他人学习。
*   分享让您了解更多。
*   分享显示您的技能。
*   分享迫使你完成。

### 伟大工具调查的提示

以下是有关如何充分利用机器学习工具调查的提示。

*   **详细但不详尽**。您对该功能的调查不需要详尽无遗，但应详细说明。您应该涵盖可以使用该功能的方式的变体，并尝试显示其限制和功能。
*   **一次性**。您无需保留调查结果。分享结果很有用，但调查不是最佳使用该功能的模板或程序。
*   **使用合适的媒体**分享。如果您是视频人员，请使用短屏幕截图分享结果。如果您是作家，请考虑博客文章或技术报告。如果您想教，请考虑创建一个分步教程。如果您是程序员，请考虑在 GitHub 上提供代码。
*   **不要花太长时间**。尽量将你的调查限制在 1 到 2 个小时。共享的详细摘要可能需要相同的时间。
*   **不要停在一个**。如果您想要善于使用工具，则应该花时间研究该工具提供的许多关键功能。
*   **制作时间**。如果该工具足以让您在项目中使用，那么重要的是您可以花时间调查学习到更深层次。

### 实例探究

以下是您可以考虑的工具特征调查的一些示例案例研究。

*   **数据分析技术**：研究如何使用工具执行特定类型的数据分析，如数据摘要或图表。
*   **数据准备技术**：研究如何使用工具执行特定类型的数据准备，例如估算缺失值或采集数据集样本。
*   **预测建模技术**：研究如何使用工具提供的特定机器学习算法来创建预测模型。
*   **模型评估技术**：研究如何使用工具执行特定的模型评估技术，如交叉验证。
*   **结果改进技术**：研究如何使用工具执行特定的结果改进技术，如算法调整或模型集成。

## 您可以调查机器学习工具

**您无需成为该工具**的专家。事实上，这种策略将帮助您提高技能，并最终成为该工具的专家。很少有人花时间实际研究他们使用的工具。如果你这样做，你会了解更多，并加速你的知识跨越而不是那些。

**你不需要成为机器学习专家**。您可能无法完全理解该工具的功能。您可以使用调查功能的过程来提高您使用该工具的技能，并在此过程中了解有关机器学习的更多信息。

**你不需要成为程序员**。并非所有机器学习工具都需要编程。您可以研究那些提供图形，Web 或命令行界面的机器学习工具。

**调查不是一个秘方**。您没有创建最佳使用功能的秘籍。您正在调查功能的各个方面以及它在项目中可能使用或不使用的方式。它甚至可能是一个对您的项目没有直接用处的功能。目标是学习和展示技能，而不是创建一个快速启动的秘籍（尽管这些问题不是相互排斥的）。

## 摘要

在这篇文章中，您发现了如何研究机器学习工具。

您了解到可以使用机器学习工具的功能调查来提高您使用该工具的技能。您还了解到，您的调查结果可用作指示器，通常用于展示您使用该工具的技能。

您发现了一个快速的 5 个步骤，可用于调查任何机器学习工具。

1.  选择要调查的机器学习工具。
2.  确定要调查的工具的功能。
3.  研究该功能，以便您知道如何有效地使用它来获得结果。
4.  在数据集上使用该工具的功能并获得结果。
5.  分享您对功能，工具和实现结果的了解。

## 你的下一步

是否有机器学习工具或要调查的工具功能？

立即调查此功能！采取行动。

1.  使用上述过程调查该功能。
2.  不要超过 1 小时才能得到结果。
3.  在下面的评论中分享您学到的知识和结果。

你对这个过程有任何疑问吗？给我发电子邮件或发表评论。