# 映射机器学习工具的景观

> 原文： [https://machinelearningmastery.com/list-machine-learning-tools/](https://machinelearningmastery.com/list-machine-learning-tools/)

那里有很多机器学习工具。

你应该使用哪些？哪些工具实际上对您的项目有用？

选择工具是一件大事。用于机器学习的工具决定了您可以实现的结果。您必须花时间为项目选择最佳工具，这一点至关重要。

在这篇文章中，您将发现一个简单的策略，您可以使用它来快速找出那些工具。

![Map the Landscape of Machine Learning Tools](img/7392ff18cfee9f362af1986752bf8c03.jpg)

映射机器学习工具的景观
照片由 [Zach Dischner](https://www.flickr.com/photos/zachd1_618/6094814673/) ，保留一些权利。

## 什么是机器学习工具的景观？

您可以使用数百甚至数千种工具进行机器学习。你需要知道那里有什么工具。您想知道，以便您可以选择最适合您项目的工具。

您可以使用您在项目中遇到的第一个工具。目前在科技新闻网站上受欢迎或正在谈论的工具。但是你怎么知道它很合适呢？您遇到的第一个工具如何才能适合您的项目？

新工具一直在发布。以及现有工具的更新和插件。您无需及时了解所有机器学习工具的发布，但如果不需要定期检入并查看其外观，则可能很有价值。

## 列出机器学习工具

解决方案是制作机器学习工具列表。

列表为您提供可以评估和选择的选项。您可以将您的需求用作搜索术语来创建列表，并且您只能捕获有关每个工具的重要详细信息作为列表中的列标题。

获得候选工具列表后，您可以进一步调查它们并将其缩小到可以在项目中实际评估或使用的一个或几个工具。

## 如何快速制作有用的列表

那么如何创建良好的机器学习工具列表呢？

您的列表应该快速创建。没有必要花太多时间来创建它们。重要的一点是，在进行可能定义项目成功的工具之前，您正在进行一些研究并给自己做出选择。

### 快速 5 步流程

以下是一个快速的 5 个步骤，您可以使用它快速创建有用的机器学习工具列表：

1.  **要求**。列出该工具所需的要求。这些将是您将用于查找候选工具的搜索词短语。这可能包括编程语言，功能，功能甚至接口。您的要求越详细，您的工具列表就越具体。
2.  **功能**：列出机器学习工具的任何非常重要的功能。这些将是您将为每个工具捕获的列标题。我建议至少包括工具的名称和工具主页的 URL。
3.  **电子表格**：创建电子表格并列出要素作为列标题。例如，您可以使用 Microsoft Excel，LibreOffice 或 Google 表格。
4.  **搜索**：使用您最喜欢的搜索引擎，并根据您的要求作为限定符搜索候选机器学习工具。
5.  **列表**：检查每个搜索结果并在电子表格中捕获候选工具（如果合适），尽可能多地填写您的功能（列）。

### 快速创建有用列表的提示

以下是制作高质量列表的 8 个技巧。

*   **创建列表**的时间不要超过 10 分钟。您希望确保使用宽刷来覆盖景观，但您不希望详尽无遗。
*   **将功能限制在 2 到 5** 之间。如果您有太多功能，可能会花太多时间寻找细节以填写电子表格。想法很快。稍后可以进行详细调查。
*   **不记录重复项**。没有必要加倍。
*   **排除显然不是竞争者的工具**。这是您的清单，可以有入学要求。如果您担心必须重新发现排除的工具，请将其列出，但添加一个名为“First Impression”的列并添加一个诚实的条目。
*   **随着时间的推移维护您的列表**。您可以保留列表并稍后投入额外时间来更新和添加新条目，甚至尝试新的搜索条件。在开始新项目或寻找新工具进行试验时，候选工具列表非常有用。
*   **添加候选工具**。当您将其添加到列表中时，不要害怕捕获您对该工具的印象。这可以大大加快创建一个简短工具列表的过程，以便以后进一步调查。
*   **分享您的清单**。在线发布，在论坛上或在社交媒体上发布。如果您发现该列表很有用，那么其他人也可能觉得它很有用。
*   **利用其他人名单**。在您搜索时，您可能会发现其他人在过去创建了类似的列表。根据列表的创建日期，它可能相关也可能不相关。在相关的电子表格（或现有电子表格的新标签页）中捕获这些链接以供日后阅读可能会有所帮助。

## 机器学习工具列表的想法

你喜欢这种策略，但你对搜索的内容没有任何想法吗？

以下是您可以创建的 10 个机器学习工具列表示例：

*   具有图形用户界面的机器学习平台列表
*   机器学习列表作为服务 API
*   机器学习列表作为服务网站工具
*   机器学习库列表（_ 你最喜欢的语言 _）
*   （_ 你最喜欢的语言 _）的深度学习库一览
*   用于（_ 您最喜欢的语言 _）的计算机视觉库列表
*   用于（_ 您最喜欢的语言 _）的自然语言处理库列表
*   用于（_ 您最喜欢的语言 _）的推荐系统库列表
*   （_ 你最喜欢的语言 _）强化学习库一览
*   （_ 你最喜欢的语言 _）的评级系统库一览

我很想看看你想出了什么。发表评论。

## 你可以制作工具清单

**你的清单不需要详尽无遗**。事实上，我建议不要创建详尽的机器学习工具列表。在大约 10 到 15 分钟的时间点，收益递减，你开始发现那些未使用的，没有文档的工具，你可能不应该靠近的人员方项目。

**你不需要保留列表**。您可以在创建列表后放弃该列表，并使用它创建一个简短列表或选择一个工具。它可以是帮助您做出决定的工件。

**您无需丢弃列表**。如果您正在处理大量项目，并且希望经常更新和重新评估工具的格局，则可能需要保留列表。我发现这是一个有用的策略。

**你不应该花太长时间制作清单**。应快速创建机器学习工具列表并使用选择工具，以便您可以开始使用项目。它是启动项目的垫脚石。不要让列表成为项目！

**你不应该对列表**有很多要求。不要过度指定您的要求列表。您可能会发现任何匹配的工具太难了。尝试将所需特征与绝对要求的工具属性分开。示例可以包括功能（例如深度学习算法）和编程语言（例如 python）。

**该列表将节省您的时间**。如果您只是搜索工具，最终会阅读大量材料，翻新并不做出决定，因为您无法一致地构建工具以进行比较。这种在评估之前制作清单的简单策略将为您节省数小时的研究和思考。

**该清单将帮助您做出更好的决策**。您不会使用您遇到的第一个工具或推荐给您的第一个工具。您将仔细考虑您的项目要求，并至少考虑多个选项。

## 摘要

在这篇文章中，您发现了一个简单的策略，您可以使用它来发现机器学习工具的风景，您可以在几分钟内将其用于项目。

建议使用快速的 5 个步骤来创建列表：

1.  列出要用作搜索词的工具要求。
2.  列出可用作列标题的工具功能。
3.  使用列标题创建电子表格。
4.  使用工具要求进行搜索
5.  从搜索结果中将条目添加到列表中。

## 下一步？

你需要一个机器学习项目的工具吗？

1.  使用此过程并列出候选机器学习工具。
2.  花费不超过 10 分钟制作您的清单。
3.  在评论中报告并分享您的列表。