# 机器学习金钱

> 原文： [https://machinelearningmastery.com/machine-learning-for-money/](https://machinelearningmastery.com/machine-learning-for-money/)

我被问到的一个问题是：

> 如何通过机器学习赚钱？

作为机器学习工程师，数据分析师或数据科学家，您可以获得机器学习技能。这是与我联系的很多人的目标。

还有其他选择。

在这篇文章中，我想强调一些其他选项，并尝试让你的齿轮转动。

鉴于可获得的大量数据，您有很多机会，您只需要思考并发现有价值的问题。这些是人们和企业将要回答的问题。

![machine learning for money](img/8e2d56487dd68e143986ffe93a293786.jpg)

机器学习
照 [401（K）2013](https://www.flickr.com/photos/68751915@N05/6757871357/sizes/l) ，保留一些权利

## 冲击首先

在我们深入研究示例域之前，先从一些方法开始。

与任何其他机器学习问题一样，您正在关注[应用机器学习](http://machinelearningmastery.com/applied-machine-learning-process/ "Solve Machine Learning Problems Step­-by­-Step")的过程，但您正在选择一个域和问题，哪里有市场可以回答问题。

1.  从域中的问题开始（很好地定义您的问题）。根据域对域的影响选择一个问题。在这里，影响可能是回报。使用理想化模型进行思想实验，可以做出完美的预测。
2.  收集解决问题所需的数据（数据选择）。
3.  清理和准备数据，使其适合建模（数据准备）
4.  对问题进行抽查算法。一定要从最简单的模型开始，并将它们用作基线。
5.  调整表现最佳的模型并使用阈值和合奏等方法来充分利用您选择的模型（改善结果）。
6.  显示结果或将系统置于操作中并设置密切监视（当前结果）。

理想情况下，您解决问题的准确性越高，回报越大（或者您可以做出的投注越大）。

## 你的初创公司

如果您有自己的企业或网络创业公司，那么您应该非常努力地利用您已经收集的数据。在 Web 创业公司中运行大量数据收集服务并不罕见，如 [KissMetrics](https://www.kissmetrics.com/) ， [Google Analytics](http://www.google.com/analytics/) 等等。如何使用这些数据来影响您的底线？

根据我的经验，这是数据分析师的工作，而不是机器学习工作，但你总是可以破坏回归模型，看看它是否比简单的五分模型提供更多提升。

我们在上一篇文章中对此进行了一些介绍。不过，这里有一些你可以研究的领域的想法：

*   **客户转换**：为转换或不转换的客户的功能建模。
*   **向上销售和交叉销售**：模拟转换为向上销售或交叉销售要约的客户的特征。
*   **收购策略**：通过收购策略模拟客户的价值。
*   **保留策略**：模拟客户保留策略的 ROI。
*   **客户流失**：模拟客户流失或不流失的功能。

从对底线的影响开始，然后回答您需要提出的问题，以便做出决策。一旦您可以回答问题并对给定的新客户进行预测，花时间设计和测试干预策略，您可以使用这些策略来影响或利用预测。

## Development

您可能是知道如何设计，创建和发布软件的开发人员或程序员。想一想你可以用机器学习方法回答的有价值的在线问题。

您是否可以制作有价值的预测或建议？

想到的一些袖手旁观的例子包括各种公开的社交媒体数据：

*   **Kick Starter** ：模拟成功或不成功的 kick starter 广告系列的功能。
*   **社交媒体资料**：在 LinkedIn，Google +或 Facebook 等网站上模拟成功社交媒体资料（访问次数或网页排名）的功能。
*   **社交新闻**：模拟一个成功的帖子的功能到社交新闻网站，如黑客新闻或 Reddit。
*   **销售页面**：为电子商务或信息产品等成功的产品销售页面的功能建模。

从洞察力到社交媒体数据赚钱是一个拥挤的空间。如果你想认真对待这个想法，那么你将不得不使用你用来模拟问题的功能。特征工程将是您的贡献，也许比实际模型更多。

这种方法很可能需要收集和处理笨拙的数据集。这些数据集不是特征的整齐矩阵。建模过程首先要表征理想的结果，评估它的预测能力，然后对客户提供预测。

## 金融和赌博

通过机器学习赚钱的明显选择是金融和赌博。我保持沉默，建议这些方面。我认为他们很可能是危险的警笛。像维纳斯捕蝇草一样，它们吸引程序员和机器学习从业者并消化它们。

![machine learning stock market](img/ff3af351e7e99a9b37ba4e1c521c6304.jpg)

将机器学习应用于股市，但要小心。
[Iman Mosaad](https://www.flickr.com/photos/imosaad/4111211837/sizes/l) 的照片，保留一些权利。

好处是决策非常明确（哪匹马会赢或哪些股票买/卖）你可以在决策背后部署自己的资金。我建议建模易于理解的问题，一些金融工具可能非常复杂。

我有高频交易和投资组合优化的脚趾。它可能是可怕的东西，也令人兴奋。我推荐纸质交易一段时间，你可以使用很棒的 API 来获取数据源。参见[我如何通过机器学习和 HFT（高频交易）](http://jspauld.com/post/35126549635/how-i-made-500k-with-machine-learning-and-hft)和[机器学习的金融应用](http://www-stat.wharton.upenn.edu/~steele/Courses/9xx/Resources/MLFinancialApplications/MLFinance.html)赚取 50 万美元。另外，你可能想看一下 [Quantopian](https://www.quantopian.com) ，

我没有试过任何赌博问题，但我已经使用了一些方法，比如评级系统，我希望在文献中有很多特色。考虑进行赛马，体育博彩（2 人游戏）和扑克等纸牌游戏。

比赛自己。关注问题，收集数据并快速定义一些基线结果。您的目标是改善自己的最佳结果，并利用任何可能有用的东西。您的目标不是超越领域专家，至少在很长一段时间内都不会。

## 比赛

您可以通过参加机器学习比赛来赚钱。我的建议是，现金奖励不是参加比赛的主要动机。通过直接寻找咨询客户，您可以赚更多钱。然而，顶级竞争者可以赢得现金奖励。

有些地方你可以找到机器学习比赛包括：

*   [Kaggle](http://kaggle.com)
*   [Challenge.gov](https://challenge.gov/)
*   [Innocentive](http://www.innocentive.com/)
*   [Tunedit](http://tunedit.org/)

比赛可以成为学习，测试和提高技能的绝佳机会。这些网站上通常有很多信息共享，您可以找到哪些算法和工具很热门。

## 摘要

为了从机器学习中赚钱，我们提到了您可以考虑的四个方面：您自己的业务，社交数据，金融和赌博以及竞争。

我找到的最好的方法是找到有问题的人，你可以用易于访问的数据（即咨询）来回答。

您是使用机器学习赚钱还是有机会学习赚钱的想法？