# 机器学习现在很受欢迎

> 原文： [https://machinelearningmastery.com/machine-learning-is-popular/](https://machinelearningmastery.com/machine-learning-is-popular/)

重要的是要知道什么是特殊的，以使机器学习成为一个有吸引力的研究领域。知道为什么它现在流行起来就像一个指南，以及该领域所做出的承诺的知识。它可以突出显示增长领域的开放式问题和方法，以及为什么会出现这种情况。

机器学习现在很流行。这种受欢迎程度的一个例子就是对斯坦福大学在线机器学习课程的回应，该课程让成千上万的人在第一年表现出兴趣。跟踪搜索术语流行度的[谷歌趋势](http://www.google.com/trends/explore#q=machine%20learning%2C%20artificial%20intelligence)也表明，对机器学习的搜索将超过人工智能搜索的速度。机器学习正在超越教科书，O'Reilly 和 Manning 等技术出版商为技术人员出版机器学习书籍。

在这篇文章中，我们将回顾导致机器学习变得流行的各种因素的融合。

## 成熟的领域

机器学习领域在过去十年中已经成熟很多，并且在过去几年中发生了很大变化。

机器学习源于人工智能领域，是从数据或经验中学习的方法的集合。这个分支包括遗传算法和群体智能等领域，可以被认为是从他们的环境中学习的方法。

在 1999 年末和 2000 年代，这些生物学启发的方法进一步分为他们自己的独特领域，通常称为元启发式或计算智能，使机器学习专注于从数据中学习的方法。

这种成熟的重点是从统计领域中大量吸取重新引用方法，并促进该领域方法的统计和概率基础。因此，机器学习 monicker 正在转向统计机器学习。

除了该领域的特性的成熟之外，该领域中使用的方法已经成熟。已经开发了强大的方法，并且在统计和概率框架中很好地理解了它们的原理。实施这些方法的工具已经成熟了 10 年和 20 年，工具如 [R 统计工作台](http://www.r-project.org/)和 [Weka](http://www.cs.waikato.ac.nz/ml/weka/) 框架。这些方法已经并将继续进入主流。

## 丰富的数据

现在有大量数据，正在收集和存储的数据正在增长。
短语如“[信息超载](http://en.wikipedia.org/wiki/Information_overload)”对普通人可获得的信息发表评论。我们通过电子邮件，社交网络，博客，RSS 和播客提供了大量信息。跟不上是很难的。缺少有用内容的担忧以及查找和跟踪最佳内容的压力是非常真实的。机器学习方法提供了用于定位和推荐最相关内容的工具，以克服信息过载。

[![Data Abundance](img/82602b6feb1698a4408edc626645b138.jpg)](https://3qeqpr26caki16dnhd19sv6by6v-wpengine.netdna-ssl.com/wp-content/uploads/2013/12/data.jpg)

照片记入 [k0a1a.net](http://www.flickr.com/photos/binary_koala/4100679811/sizes/l/) ，保留一些权利

我们每天使用和交互的系统都在创建描述这些交互的数据。像“[数据耗尽](http://en.wikipedia.org/wiki/Digital_footprint)”这样的短语用于描述该数据的创建。这些数据对收集它的组织很有价值，如果数据可用，它对数据创建的发起者可能很有价值。机器学习提供了将从这种废气中收集的数据转化为有意义的信息的方法，从中推动决策制定。

有些数据正在并且可以收集，这些数据尚未为个人或之前的规模收集。像[量化自我](http://quantifiedself.com/)这样的团体正在探索从心跳，呼吸，步骤等生物信息中跟踪和收集人们日常信息的所有方法，以及对话和口语等交互。移动电话覆盖有传感器，可以监控周围区域的方向，位置，音频和视频。

这些数据流可以在人员，地点和组织等汇合点进行会议，并且可以回答甚至没有构思的问题都可以回答。

一个随意的例子是在一个位置（如你的家庭办公室）建模你的精神状态（如厌倦或拖延）并触发干预（如鼓励有针对性的行动）以优化某些目标（如生产力）。机器学习方法提供了使用大量看似不同的数据来模拟复杂问题的能力。

## 丰富的计算

计算量充足且价格便宜。这就是为什么有大量数据以及为什么我们有更强大的机器学习方法。

[![Abundant Computation](img/c2b1cdff1bfafce5084bf91f6b69a76a.jpg)](https://3qeqpr26caki16dnhd19sv6by6v-wpengine.netdna-ssl.com/wp-content/uploads/2013/12/Abundant-Computation.jpg)

照片归 [torkildr](http://www.flickr.com/photos/torkildr/3462607995/sizes/l/) 所有，保留一些权利

只要我记得，我已经为长期算法编写了脚本和程序。我会非常认真地想要回答什么问题（比如哪种算法更好，哪种算法参数更好等），编写脚本或程序来回答这个问题并在一夜之间运行实验，同时我在工作甚至整整一周。

世界已经发生了很大的变化，并且有非常强大的计算机，你可以每小时租金到几美元，并在巨大的数据集上进行大量的实验。

便宜的丰富计算允许您在托管基础架构上运行实验，这些实验在您的工作站或家用 PC 上永远不会考虑运行。

这种丰富的计算也意味着您可以编写比其使用的更多的系统。在这种情况下，运行计算机游戏的所有 CPU 时间都被提供给图形引擎。慢慢地，稳定地，AI 可以进行越来越多的计算，使计算机控制的对手更聪明，更有吸引力。这通常用于计算的类比。我们有这么多而且它太便宜了，我们积极地设计系统，以便从核心活动中抽走循环来做我们以前不会考虑的事情。例如，为个人用户建模以定制应用程序和网站的用户界面，并在 Web 初创公司中运行有关客户行为的高级报告，这两种操作通常以前只适用于大型企业。

机器学习很受欢迎，因为计算量大且便宜。丰富而廉价的计算推动了我们收集的大量数据以及机器学习方法能力的提高。

在这篇文章中，您了解到机器学习现在很流行有三个原因：

*   该领域在身份以及方法和工具方面已经成熟。
*   有大量的数据需要学习。
*   运行方法有大量的计算。

您是否对如何利用丰富的计算和数据以及机器学习的成熟领域有一些想法？发表评论。