# 快速了解任何机器学习工具（即使您是初学者）

> 原文： [https://machinelearningmastery.com/machine-learning-tool-templates/](https://machinelearningmastery.com/machine-learning-tool-templates/)

您如何快速了解机器学习工具？

使用正确的工具可能意味着快速获得良好预测与您无法交付的项目之间的差异。您需要在使用它们之前评估机器学习工具。

您需要知道机器学习工具适合您，适合您的项目并且您可以信任它。

在这篇文章中，您将了解如何快速设计和填写一页的算法描述模板。您可以使用此类机器学习工具模板来评估机器学习工具，并直接与其他工具进行比较和对比。

![Machine Learning Tool Template](img/ff364bc099223e09aae087c083ec6157.jpg)

机器学习工具模板
照片由 [visualpun.ch](https://www.flickr.com/photos/visualpunch/5218426053/) ，保留一些权利。

## 关于机器学习工具的问题

很难发现机器学习工具是否适合您。

为项目选择和采用机器学习工具是一项重要决策。它必须提供满足项目目标所需的功能。它还必须提供接口，文档，支持以及在实践中实际使用它所需的一切。

有时，了解工具的工作原理或工具的局限性至关重要。您始终需要知道您可以信任该工具来提供其功能，并在您需要时提供足够的支持。

您对机器学习工具有疑问，找到答案可能很难，有时候也很荒谬。更糟糕的是，一旦得到答案，您就没有明确的方法来评估您对该工具或上下文所学到的一切，以便将其直接与其他工具进行比较。

## 设计和填写工具说明

答案是记录您对机器学习工具的所有具体问题。
花点时间考虑所有问题，如果回答，将允许您决定一个工具是否适合您，以及它是否比您正在考虑的其他工具更适合或（未比较）。

您可以使用这些问题创建一个小的单页工具描述模板。通过研究每个问题，您可以快速填写该模板，并对该工具进行高度定制和定制的描述。

它提供了一种结构化的方法来研究和捕获您需要了解的有关该工具的信息，并提供评估和参考，以便与其他工具进行比较。

您还可以存储，更新，共享并在将来的项目中反复使用它。

## 描述任何机器学习工具

使用系统过程，您可以描述任何机器学习工具。

### 快速的 5 步流程

以下是描述任何机器学习工具的快速 5 个步骤。

1.  **选择工具**：选择要描述的工具。这可能来自您之前创建的一个简短工具列表。或者，它可能是一个新工具或工具引起您的注意，您想要了解更多。
2.  **识别问题**：列出您对该工具的疑问。具体问题很有用（例如什么是许可协议？）。更可能的是开放式问题需要信息摘要（例如[应用机器学习过程](http://machinelearningmastery.com/machine-learning-checklist/)的工具涵盖哪些任务？）。
3.  **创建模板**：将问题放在一个新的文本文档或电子表格中，每个文本都有空格，以便您可以填写答案。这是您的机器学习工具模板。您可能希望保存未完成的模板，并在将来的项目中重复使用它。
4.  **研究**：使用您最喜欢的搜索引擎并研究您的工具。一次关注一个问题，并使用问题中的语言作为搜索条件。尝试在每个问题上花费几分钟来捕捉答案的高级或广泛笔画。
5.  **完整模板**：使用搜索结果填写模板。使用项目符号并关注对问题和您有用且有意义的突出细节。不要将粘贴复制到文本块中。这无助于您更好地理解该工具。

### 伟大工具描述的提示

以下 8 个提示可帮助您制作出色的机器学习工具说明。

*   **快速完成模板**。创建模板的时间不要超过 30 到 60 分钟。工具和模板不是项目。快速完成，捕获广泛的笔触并使用模板。您可以随时回来进行另一轮研究。
*   **使您的模板成为目标**。不要试图捕获机器学习工具的所有属性。在确定它是否对您有用之前，请关注您真正需要回答的关于工具的 5 到 10 个问题。这些问题很可能会集中在该工具的功能和您对该工具可以提供的信任。
*   **采用一致的模板**。在评估不同工具时，请考虑使用相同的模板。使用相同的结构将使得与其他工具的直接比较和对比变得更加容易。
*   **使用电子表格**。如果您不喜欢写作，请考虑使用电子表格。将属性列为列标题，并将每一行用作标题下的新点。它会迫使你变得简洁。
*   **分享你的结果**。与朋友，同事或公开分享您的结果。如果您对评估它的工具感兴趣，那么很可能其他人可能并且可能从您的描述中受益。
*   **建立你的结果**。您可以在将来重新访问工具说明并进行更新。如果工具在新版本上更改或您即将开始新项目，这将非常有用。
*   **了解更多详细信息**。如果有问题无法得到明确答案，请考虑通过电子邮件或发布论坛消息与用户甚至该工具的开发人员联系。明确而直接的问题将是最有效的方法。
*   **使用项目符号**描述。这是一种很好的方法，特别是如果你不喜欢写作。它使描述清晰，有针对性和有用。

### 模板示例问题

以下是可用于构建机器学习工具模板的 10 个示例问题。

*   该工具的全名，昵称和首字母缩略词是什么？
*   该工具的许可协议是什么？
*   该工具可以使用哪些编程语言？
*   为工具提供了哪些接口（例如图形，命令行，编程等）？
*   该工具周围有哪些社区（例如论坛，插件，博客等）
*   谁创造了这个工具，何时以及为什么？
*   该工具的更新频率以及最后一次发布的时间（例如最近的发布时间表）？
*   该工具涵盖了应用机器学习过程中的哪些任务？
*   该工具提供哪些建模算法？
*   可以用来掌握工具的关键资源是什么（例如书籍，论文，网站）？

## 您可以描述机器学习工具

**您的描述不需要完整**。您只需要了解您感兴趣的工具的详细信息，并帮助您决定它是否对您的需求有用。不要创建详尽的工具描述，这对您来说是一个很大的浪费时间。该工具不是项目。

**你不需要成为机器学习专家**。您不需要知道所有算法是什么或所有术语的含义。您只需要能够描述对您来说很重要的工具属性，以便能够做出决定。

**您无需成为该工具**的专家。创建工具描述既不要求您成为工具专家，也不会让您成为工具专家。这是一个可以用来快速了解该工具的过程。您可以从网站，书籍，论文，博客等中收集所需的所有信息。

**你不需要成为程序员**。许多机器学习工具都是需要您成为程序员才能使用它们的库。但是也有许多机器学习工具提供图形，Web 和命令行界面。如果您不是程序员，请专注于描述可以在不编写代码行的情况下使用的工具。

**你不需要成为作家**。您对该工具的描述不需要很长，也不需要写得很好。您可以使用项目符号捕获所需的信息。您甚至可以使用电子表格来创建说明。

## 摘要

在这篇文章中，您了解了如何快速创建机器学习工具的描述。

机器学习描述可用于评估机器学习工具，并将其与其他机器学习工具进行比较和对比。它是帮助您确定给定的机器学习工具是否适合您的需求或项目的宝贵帮助。

您可以使用以下 5 个步骤快速描述任何机器学习工具：

1.  选择要描述的工具。
2.  确定要捕获的工具的属性。
3.  将文本文档中的工具属性布局为模板供您完成。
4.  使用书籍，论文，网站，论坛和您认为有用的任何其他来源在线研究该工具。
5.  使用搜索结果使用项目符号填写模板。

## 你的下一步

立刻描述机器学习工具！

1.  选择要描述的机器学习工具。
2.  使用上面的过程来描述它。
3.  报告回来，我很想看到你的描述。

你对这个过程有任何疑问吗？给我发电子邮件或发表评论。