# 找到你的机器学习部落

> 原文： [https://machinelearningmastery.com/machine-learning-tribe/](https://machinelearningmastery.com/machine-learning-tribe/)

### _ 入门并避免得到错误的建议 _

机器学习是一个充满算法和数据的迷人而强大的研究领域。

问题是，有很多不同类型的人对机器学习感兴趣，每个人都有不同的需求。重要的是要了解您希望从机器学习中获得什么，并根据这些需求定制自学。

如果你不这样做，你可以很容易地走下兔子洞而迷路，失去兴趣而不能得到你想要的东西。

### 找到你的部落！

在这篇文章中，您将发现对机器学习感兴趣的 10 个主要群体。我叫他们**机器学习部落**。

您将发现每个部落最有价值的一般需求和资源类型。

重要的是，你可以回顾 10 个部落并发现你的位置，找到像你这样的其他人的安慰，并了解你的下一步可能是什么。

你在哪里适合？发表评论并告诉我。

[![Find Your Machine Learning Tribe](img/e0ebd13c19bf49005b7472eb89925705.jpg)](https://3qeqpr26caki16dnhd19sv6by6v-wpengine.netdna-ssl.com/wp-content/uploads/2015/08/Find-Your-Machine-Learning-Tribe.jpg)

找到你的机器学习部落
[照片](https://www.flickr.com/photos/130625175@N03/17466998874)，保留一些权利。

## 避免部落不匹配，这很常见

你对机器学习感兴趣。你四处询问，建议使用特定的课程或书籍。

几个小时后，你会感到沮丧，但你不确定为什么。

这件事发生在你身上吗？

这是因为你选择的资源非常好，它可能不适合你的特定环境。

这是一个常见问题，我称之为不匹配问题。

### 开发人员和教科书的经典示例

一个典型的例子是有兴趣解决一次性问题的开发人员。他们被推荐为机器学习教科书。

他们购买它，开始阅读，永远不会超过第一章。

对于刚毕业 4 年数学课程的研究生机器学习班的学生来说，教科书是完美的。

对于开发人员而言，它几乎没用，他们在职业生涯的 10 年里将机器学习视为提供结果的工具。

这就是了解对机器学习感兴趣的不同群体以及您所属的群体至关重要的原因。这样您就可以找到像您这样的其他人，并开始使用实际上可以帮助您获得所需解决方案的资源。

## 10 机器学习部落

在本节中，我们列出了 10 个对机器学习感兴趣的不同人群。

我给出了每个名字，突出了他们的主要目标和兴趣，并列出了该组中的人员可以在接下来的步骤中使用的资源。我还根据商业，学术，工程和数据等一般主题对小组进行了分组。

这些组可能有一些重叠。您也可能属于其中一个或多个。那很好（我很乐意在评论中听到它）。

此外，我们正在限制我们对机器学习的兴趣，而不是所有更广泛的数据科学。

让我们潜入。

### 部落概述

这是 10 个部落的快照：

*   **商业部落**
    *   1）具有一般兴趣的商业人士
    *   2）经理对交付项目感兴趣
*   **学术部落**
    *   3）本科或研究生班的机器学习学生
    *   4）机器学习研究员对影响领域感兴趣
    *   5）普通研究员对他们的问题建模感兴趣
*   **工程部落**
    *   6）程序员对实现算法感兴趣
    *   7）开发人员有兴趣提供一次性预测
    *   8）工程师对开发更智能的软件和服务感兴趣
*   **数据部落**
    *   9）数据科学家对获得更好的业务问题答案感兴趣
    *   10）数据分析师对更好地解释数据感兴趣

![Machine Learning Tribes](img/59b04853a55679c6b712c2143917cd85.jpg)

机器学习部落的思维导图

### 商业部落

通常，这些人对组织中有效利用机器学习感兴趣，但不一定对算法或工具的细节感兴趣。

商务人士可能会使用 _ 商业智能 _ 或 _ 预测分析 _ 等术语，这两个术语都是可以利用机器学习技术的更通用的领域。

#### 1）具有一般兴趣的商业人士

这可能是任何人从一位高管到一位听说过机器学习的顾问，并且正在寻求战略性地利用它，也许是在即将开展的项目或计划中。

这不是我的领域，但是一些可能对更多战略思考有用的资源包括：

*   Gartner 的[高级分析平台魔力象限](http://www.gartner.com/technology/reprints.do?id=1-2AHPOU0&ct=150225&st=sb)，2015 年
*   Gartner 的[机器学习推动了数字业务](https://www.gartner.com/doc/2820120/machine-learning-drives-digital-business)，2014 年
*   麦肯锡的[机器学习高管指南](http://www.mckinsey.com/insights/high_tech_telecoms_internet/an_executives_guide_to_machine_learning)，2015

我还会在下一节中为“_ 经理 _”推荐这些书。

![Gartner Magic Quadrant for Advanced Analytics Platforms](img/1db7bfcbb681905833095a6b5c0cb893.jpg)

Gartner 高级分析平台的魔力象限来自 [Gartner](http://www.gartner.com/technology/reprints.do?id=1-2AHPOU0&ct=150225&st=sb) ，保留所有权利。

#### 2）经理对交付项目感兴趣

这是一个项目经理或类似的领导职位，正在使用机器学习的项目。它可能是项目的核心特征或项目的核心。

有用的资源将是关于该领域的高级视角，其涉及各种类型的问题和算法，而不会涉及太多细节。

查看以下书籍：

*   [预测分析：预测谁将点击，购买，谎言或死亡的能力](http://www.amazon.com/dp/1118356853?tag=inspiredalgor-20)
*   [商业数据科学：您需要了解的数据挖掘和数据分析思考](http://www.amazon.com/dp/1449361323?tag=inspiredalgor-20)
*   [Data Smart：利用数据科学将信息转化为洞察力](http://www.amazon.com/dp/111866146X?tag=inspiredalgor-20)

[![Amazon Image](img/1e5e23c34e00d066d9e5022e49b1d746.jpg)](http://www.amazon.com/dp/1118356853?tag=inspiredalgor-20)

### 学术部落

一般来说，这些人是从学术角度对机器学习感兴趣的人。他们可能是学生（本科生或研究生）或与大学有关的其他人。

其他的例子是博士后，研究员和各种讲座。

学术部落可能会花费大量时间研究研究论文中的特定机器学习算法。您可以在“[如何研究机器学习算法](http://machinelearningmastery.com/how-to-research-a-machine-learning-algorithm/)”中了解有关研究算法的更多信息。

#### 3）本科或研究生班的机器学习学生

机器学习的学生很可能上课并且对与技术和算法相关的超特定问题感兴趣。

学生具有专注的结构和深入研究材料的时间。他们最好配有教科书。一些最好的机器学习教科书如下：

*   [从数据中学习](http://www.amazon.com/dp/B00C7EXC2A?tag=inspiredalgor-20)
*   [机器学习：概率视角](http://www.amazon.com/dp/0262018020?tag=inspiredalgor-20)
*   [模式识别与机器学习](http://www.amazon.com/dp/0387310738?tag=inspiredalgor-20)
*   [统计学习要素：数据挖掘。推理。和预测](http://www.amazon.com/dp/B00GSCXVN2?tag=inspiredalgor-20)

#### 4）机器学习研究员对影响领域感兴趣

机器学习研究人员有兴趣深入了解机器学习的一个方面，以便为扩展该领域做出微小的补充。

研究人员对研究论文，期刊以及与之相关的组织和网络感兴趣。

教科书没有削减它，它们是次要来源并且已经过时了。

一些备受瞩目的机器学习期刊和会议记录是：

*   [机器学习研究期刊](http://www.jmlr.org/)（JMLR）
*   [神经信息处理系统](https://nips.cc/)（NIPS）
*   [知识发现和数据挖掘](http://www.kdd.org/)（SIGKDD）
*   [机器学习国际会议](https://en.wikipedia.org/wiki/International_Conference_on_Machine_Learning)（ICML）

查看 Quora 问题的最佳答案“[关于机器学习的最佳会议和期刊是什么？](https://www.quora.com/What-are-the-best-conferences-and-journals-about-machine-learning) “。

这是人工智能中排名前 50 位的期刊[的便捷列表。](http://www.scimagojr.com/journalrank.php?category=1702)

#### 5）普通研究员对他们的问题建模感兴趣

一般研究人员可能对机器学习感兴趣，但作为一种工具。他们很可能对使用自己的数据构建描述性或预测性模型感兴趣。

例如，来自客户研究，地质学或生物学领域的科学家拥有自己的数据集，并且正在寻求创建模型以进行预测和/或更好地理解潜在问题。

他们通常对模型准确性不太感兴趣，对模型可解释性更感兴趣。因此，从统计学中借鉴的更简单易懂的方法是优选的，例如线性回归和逻辑回归。

然而，需要良好的系统过程。

我会推荐“_ 工程部落 _”下的资源，特别是“_ 开发人员有兴趣提供一次性预测 _”。另请参阅“_ 数据部落 _”下的“_ 数据科学家 _”小组。

### 工程部落

通常，一组开发人员习惯于为软件问题提供解决方案并希望结合机器学习。

对于希望进入机器学习的工程师，我推荐的一个好的通用帖子是“[程序员机器学习](http://machinelearningmastery.com/machine-learning-for-programmers/)”。

工程师部落可以在机器学习社区获得大量帮助和支持，例如 Q＆amp; A 网站上的机器学习社区。有关更多信息，请查看帖子“[机器学习社区](http://machinelearningmastery.com/machine-learning-communities/)”。

#### 6）程序员对实现算法感兴趣

程序员开发机器学习技能的一个好方法是使用他们现有的编程技能并从头开始实现机器学习算法。

我在博客文章“[通过实施他们从头开始](http://machinelearningmastery.com/understand-machine-learning-algorithms-by-implementing-them-from-scratch/)了解机器学习算法”中谈论了这个方法，并提供了很好的技巧和资源。

我从博客文章中推荐的这种方法的三本书是：

*   [Scratch 数据科学：Python 的第一原理](http://www.amazon.com/dp/149190142X?tag=inspiredalgor-20)
*   [机器学习在行动](http://www.amazon.com/dp/1617290181?tag=inspiredalgor-20)
*   [机器学习：算法视角](http://www.amazon.com/dp/1466583282?tag=inspiredalgor-20)

[![Amazon Image](img/bbd25613cb12b55b69497c7479119553.jpg)](http://www.amazon.com/dp/1466583282?tag=inspiredalgor-20)

#### 7）开发人员有兴趣提供一次性预测

开发人员不一定是优秀的程序员，并且不需要编程来开发和提供准确可靠的预测模型。

在商业环境中可能需要一次性预测模型来获得它可以提供的预测集。它也是一个强大的自我模型，用于练习数据集甚至机器学习竞赛。

通过系统地处理问题并提供独立模型，您可以学到很多东西。

*   [数据挖掘：实用机器学习工具和技术](http://www.amazon.com/dp/0123748569?tag=inspiredalgor-20)
*   [应用预测建模](http://www.amazon.com/dp/1461468485?tag=inspiredalgor-20)

在“[处理机器学习问题的过程](http://machinelearningmastery.com/process-for-working-through-machine-learning-problems/)”中查看我的系统过程，以便端到端地处理机器学习问题。

#### 8）工程师对开发更智能的软件和服务感兴趣

有兴趣将机器学习添加到其软件项目的工程师需要一些算法知识，如何端到端地解决问题的一些知识以及如何使算法在操作环境中可靠地运行的知识。

这一群人从前面描述的两个群体中成长，最好被描述为机器学习工程师。他们希望使用能够提供可靠和准确结果的快速算法，从而平衡这些问题。

该小组还大量使用机器学习库和基础设施。

关于快速启动机器学习库的一些有用资源包括：

*   [使用 Python 构建机器学习系统](http://www.amazon.com/dp/B00E7NC9D2?tag=inspiredalgor-20)
*   [学习 scikit-learn：Python 中的机器学习](http://www.amazon.com/dp/1783281936?tag=inspiredalgor-20)
*   [实用数据科学与 R](http://www.amazon.com/dp/1617291560?tag=inspiredalgor-20)
*   [R 机器学习](http://www.amazon.com/dp/1784393908?tag=inspiredalgor-20)

[![Amazon Image](img/9d0c93a673e18a64f270b395e5fba9ae.jpg)](http://www.amazon.com/dp/1784393908?tag=inspiredalgor-20)

另外，查看帖子“[构建生产机器学习基础设施](http://machinelearningmastery.com/building-a-production-machine-learning-infrastructure/)”。

### 数据部落

通常，这些人群主要处于数据角色，但可能需要利用机器学习。

#### 9）数据科学家对获得更好的业务问题答案感兴趣

当你是一名数据科学家时，学习并没有停止。

您必须掌握最新的数据流，技术和算法。这包括描述数据和创建预测模型所需的机器学习技术。

数据科学家可以从“_ 工程部落 _”下列出的更多应用资源中获取他们所需的资源，以及“_ 学术部落 _”下列出的更多理论资源。

然而，包含这种组合的一些以数据科学为中心的机器学习资源是：

*   [应用预测建模](http://www.amazon.com/dp/1461468485?tag=inspiredalgor-20)
*   [统计学习简介：在 R](http://www.amazon.com/dp/1461471370?tag=inspiredalgor-20) 中的应用
*   [黑客机器学习](http://www.amazon.com/dp/1449303714?tag=inspiredalgor-20)

#### 10）数据分析师对更好地解释数据感兴趣

数据分析师主要关注在商业利益背景下解释数据。有时机器学习算法对于提供更强大的模型很有用。主要是描述性模型，但有时也是预测性的。

与“_ 一般研究员 _”一样，该小组可能在统计和统计推断方面具有良好的基础。此外，鉴于他们最有可能对描述性模型感兴趣，经典方法如线性和逻辑回归可能就足够了。在结果模型中对准确性的可解释性。

上面的许多相同资源都是有用的，尽管可能有更多的统计推断立场。

## 行动步骤

在这篇文章中，您发现了 10 个对机器学习感兴趣的不同人群。

这是一个方便的思维导图，总结了 10 个部落：

![Machine Learning Tribes](img/59b04853a55679c6b712c2143917cd85.jpg)

Mind Map of Machine Learning Tribes

您的操作步骤是查看列表并找出您所属的位置。

**你的部落是哪一组？** 在下面发表评论让我知道。