# 机器学习在一年

> 原文： [https://machinelearningmastery.com/machine-learning-year/](https://machinelearningmastery.com/machine-learning-year/)

### 从开发人员到机器学习从业者，
_ 你也可以！_

Per Borgen 是一个灵感来源。

他从开发人员转变为机器学习从业者。他解释了他是如何做到的。

在这篇文章中，您将发现 Per 在过渡时学到的经验教训。

您将发现他采用的两种方法以及如何使用它们。而且你会发现 Per 对初学者的建议，就像你一样，也希望能够进行过渡。

而且你会发现 Per 对初学者的建议，就像你一样，也希望能够进行过渡。

让我们开始吧。

![Machine Learning In A Year](img/9253594af8e6bcfae00c1c1975a01d49.jpg)

机器学习一年
摄影： [Andreanna Moya](https://www.flickr.com/photos/andreanna/2837855969/) ，保留一些权利。

## 一周的机器学习

Per 的第一个实验涉及花一周时间进行机器学习并了解他能走多远。

像许多对机器学习感兴趣的学生一样，他已经完成了 MOOC 的一半，并且无法将他学到的知识转化为实际解决问题。

他将他经验丰富的“[机器学习一周](https://medium.com/learning-new-stuff/machine-learning-in-a-week-a0da25d59850)”命名为，或者真正的 5 天。

本工作周分解如下：

1.  **星期一**：学习基础知识。
2.  **星期二**：对新数据做出预测。
3.  **星期三**：从头开始编写算法。
4.  **周四**：参加比赛。
5.  **星期五**：关于 Udacity 的研究。

他的方案非常实用，2 天专注于建模，意图获得结果，另一天专注于实现算法。

**我真的很喜欢。**

他评论说：

> 当你意识到你可以开始使用毫升来解决现实生活中的问题时，这是一个关键时刻。

我认为 Per 周的重要内容是，有可能在一个工作周内使**非常真实**和**非常有价值的进展**。

在 20 到 40 年的职业生涯中，五天不算什么。

他自己说：

> 如果您对进入机器学习感兴趣，我强烈建议您开始几天或晚上，然后潜入它。

Per 建议采用自上而下和结果优先的方法开始，正如我在机器学习掌握中所教导的那样：

> 如果您还没有为重物做好准备，请选择自上而下的方法，并尽快解决问题。

## 一年的机器学习

每走得更远。

一年后，他写了一篇后续帖子，宣布他的第一个机器学习项目正在进行中。

这篇文章的标题是“[机器学习一年](https://medium.com/learning-new-stuff/machine-learning-in-a-year-cdb0b0ebd29c)”，详细介绍了他去年学习机器学习的方式。

他坚持自上而下的方法，这无疑有助于过渡，他说：

> 事实上，您不需要太多的数学就可以开始使用机器学习，而且您不需要专业学位就可以使用它。

他一年的机器学习自学有很多起伏。他的年度最终导致他在一个模型上工作以提高他的工作场所的销售额。

做得好！

### 得到教训

Per 在他的整个帖子中汲取了经验教训。

我的观点略有不同。我总结了他从他的经历中学到的 5 个关键课程：

*   1.采用简单的自上而下的方法而不是自下而上的理论方法。
*   2.您不需要更高的学位，只需专注于提供价值。

> 它也让我摆脱了只有拥有硕士学位或博士学位的专业人士的妄想。

*   3.也许跳过 MOOC，或者找一个适合你的 MOOC。

> 我也没有完成它，因为我很少使用 MOOC。 ......如果我能及时回顾，我会选择 Udacity 的机器学习入门，因为它更容易并且使用 Python 和 Scikit Learn。通过这种方式，我们可以尽快弄脏手，获得信心，并获得更多乐趣。

*   4.不要试图同时学习机器学习和新的编程语言。

> 在尝试编写 ml 算法的同时学习一门新语言对新手来说太难了。

*   5.通过竞赛实践真实数据的实践。

> 这方面的主要内容是通过试验算法和数据来迭代地改进结果的经验。

### 专业提示

我发现其中隐藏了两个专业技巧。

我认为两个掘金可以真正加速进步。

1.  找一个教练来支持并一路建议你。
2.  询问并查看您是否可以在工作中学习机器学习。

考虑尝试这些策略来真正加快进度。

### 对于初学者

我真的很喜欢他的最后评论。对初学者来说非常鼓舞人心：

> 达到这一点肯定是一段漫长的旅程。但也快一个;当我在一周的项目中开始我的机器学习时，我当然没有希望在一年内实际使用它。但这是百分之百的可能。如果我能做到，其他任何人都能做到。

如果 Per 可以做到，为什么不能呢？

## 摘要

在这篇文章中，您了解了 Per Borgen 如何从开发人员转变为机器学习从业者。

你了解到：

*   您可以在一周内在机器学习方面取得非常实际的进展。
*   你不需要从理论开始或获得更高的学位。
*   您可以在一年内完成转换，如果您坚持并且练习，则可以更少。

**你从 Per 的经历中得到了什么？**
**你是否受到启发？**
发表评论，我很想听听你的想法。