# 使用秘籍的任何机器学习工具快速启动

> 原文： [https://machinelearningmastery.com/proceduralize-machine-learning-tools/](https://machinelearningmastery.com/proceduralize-machine-learning-tools/)

您如何最好地使用机器学习工具进行准确的预测？

您只选择并使用机器学习工具，以便在机器学习项目中使您的生活更轻松。这些工具可以帮助您构建可以进行准确预测的模型。

重要的是，您知道如何在此过程中最好地使用它们。

在这篇文章中，您将发现一个简单的 5 步过程，您可以使用将任何机器学习工具映射到应用机器学习的过程。

通过对工具的使用进行程序化，您可以创建可在当前和未来项目中遵循或复制的逐步秘籍，以快速从工具中获得最佳结果。

![Machine Learning Recipes](img/6dac8854ce9c3fa395c1708ab33eec6a.jpg)

机器学习秘籍
摄影： [Mathew Packer](https://www.flickr.com/photos/mat-packer/9312635900/) ，保留一些权利。

## 使用您的工具进行准确的预测

机器学习工具具有如此多的特性和功能，其中大多数都难以理解或隐藏在文档的后面。

您应该使用机器学习工具的哪些功能？

了解如何最好地使用所选择的机器学习工具以构建准确的预测模型至关重要。您需要知道该工具的哪些功能实际上与您在任何项目中执行的应用机器学习的[过程相关，以进行准确的预测。](http://machinelearningmastery.com/process-for-working-through-machine-learning-problems/)

如何最好地利用项目的每个功能？

每个功能都可以在文档中进行配置和不一致描述，或者根本不进行描述。您需要知道如何在项目中最好地使用该工具的每个功能。你不能每次都重新学习这个，或者从最后一个项目的细节中复制粘贴它。

## 将工具功能映射到项目任务

解决方案是预先执行工作，并了解如何最好地使用项目服务中的每个功能。

您需要识别可能为应用的机器学习过程的特定子任务提供结果的那些功能。此映射提供了一些简短的功能列表，值得进一步了解和弄清楚。

一旦您弄清楚如何很好地为您的流程和项目使用每个功能，您就可以为它创建一个简短的可重用过程。这可能是一个逐步编号的事件列表或一个小代码示例，您可以复制和粘贴并用作起点。

这些秘籍一起提供了使用该工具的最佳实践指南，以及您可以在当前或未来项目中使用的快速入门，以充分利用该工具。

## 程序化任何机器学习工具

您需要使用系统过程来对机器学习工具进行程序化。

### 快速 5 步流程

1.  **选择工具**。选择要进行程序化的工具。这可能是您之前列出或描述的工具。它甚至可能是您经常使用的工具，并且您希望标准化您使用它的方式。
2.  **布局流程**。布置与工具相关的应用机器学习的[过程中的步骤。在文本文档中这样做可能会有所帮助。具体而言，该过程中的步骤以及该工具可能支持的每个步骤下的任何任务。](http://machinelearningmastery.com/machine-learning-checklist/)
3.  **将功能映射到任务**。查看工具的功能并将其映射到您在上一步中概述的机器学习项目的任务。在文本文档中列出每个任务下的相关工具功能可能会有所帮助。
4.  **研究特色**。研究该工具的每个映射功能并发现如何使用它。这可能包括阅读 API 文档和查看教程。了解您需要了解的内容，以便在应用的机器学习项目中最小化地使用该功能进行离散任务。
5.  **创建程序**。创建使用每个映射功能的过程。这可能是带有编号列表的秘籍。或者，这可能是使用该功能的完整的自包含和最小代码示例。
    收集所有秘籍将为您提供一个快速入门指南，以便最好地使用该工具在任何应用的机器学习项目中进行准确的预测。

### 程序化工具的提示

以下是 9 个提示，您可以使用这些提示创建机器学习工具的优秀程序。

*   **专注于任务**。不要对机器学习工具的每个功能进行程序化。这将浪费你的时间。只关注工具涵盖的应用机器学习过程的那些任务。
*   **关注结果**。秘籍必须提供结果。对于算法，这将是预测，对于分析，这可以是图。
*   **保持简单**。不要对该工具提供的特征或技术的所有变体进行程序化。专注于一个并保持程序尽可能小以显示结果。
*   **效率可读性**。不要陷入最佳实践代码标准或极端细节。使秘籍可读和简单。它们不是用于操作用途，仅作为使用该工具的起点。
*   **复制粘贴秘籍**。每个秘籍必须完整，以便可以立即复制和粘贴并运行。
*   **使用简单的标准数据集**。在需要时使用易于理解的小数据集来演示工具的功能。考虑使用来自 UCI 机器学习库的数据集。
*   **保持最新**。在对该工具进行程序化之后，请考虑使用该工具的新版本使其保持最新。即使经常刷新程序也可能有助于使它们更小巧，更简洁。
*   **使用修订控制**。考虑在修订控制中存储过程。如果它们打算供整个团队使用，这是一个很好的策略。它还允许它们异步更新和同行评审。
*   **样本输出**。考虑为秘籍提供样本输出，以了解期望的内容。这对于更多可视化秘籍（例如用于数据分析和绘图的秘籍）非常有用。

### 实例探究

以下是 3 个可能对您有用的程序化工具的案例研究。

*   **图形用户界面**。您可以通过记下获得可重复结果所需的鼠标点击秘籍，为具有图形用户界面的工具创建秘籍。
*   **算法库**。如果您正在编写机器学习算法库的程序，请提供一个简短的代码秘籍来运行库中的每个算法。
*   **平台**。如果您正在对平台进行程序化，那么请考虑为应用机器学习过程中的每个步骤创建秘籍，以及完成端对端案例研究，以展示子任务如何组合在一起。

## 您可以对机器学习工具进行程序化

**你不需要成为程序员**。您可以对不需要任何编程的工具进行程序化，例如 [WEKA 机器学习工作台](http://machinelearningmastery.com/how-to-run-your-first-classifier-in-weka/)，它提供图形用户界面和命令行界面。

**您无需成为该工具**的专家。您可以研究在应用机器学习过程的任务中使用工具的特定功能需要了解的内容。您只需要在需要时学习所需内容。

**你不需要成为机器学习专家**。您可能会遇到您不完全理解的模型和技术。这很好，它扩大了你的曝光率。您仍然可以程序化如何使用这些功能。通过这样做，您将对这些技术可以提供的结果类型有实际的了解。您也可以在以后更详细地研究它们。

**你不需要成为作家**。使用点数并创建可以遵循的逐步秘籍。对于编程库，创建一个可以复制和粘贴的完整代码示例。

## 摘要

在这篇文章中，您通过为应用机器学习过程的任务创建过程，了解了如何充分利用机器学习工具。

该工具的过程可用于您的项目，以最好地使用该工具满足您的需求。它们还可以用作未来启动新项目的指南。

程序化机器学习工具的过程分为 5 个快速步骤：

1.  选择要进行程序化的工具。
2.  在与工具相关的应用机器学习过程中布置任务。
3.  将工具的功能映射到应用机器学习项目过程中的任务。
4.  研究工具的每个映射功能并学习如何使用它。
5.  为工具的每个映射功能创建一个过程，您可以使用该过程快速获得结果。

## 你的下一步

您的下一步是对机器学习工具进行程序化。

1.  选择要进行程序化的工具。
2.  使用上述过程创建过程，即使它是针对一个任务。
3.  分享你的结果，我很想知道你的想法。

你对这个过程有任何疑问吗？给我发电子邮件或发表评论。