# 现实世界机器学习问题之旅

> 原文： [https://machinelearningmastery.com/tour-of-real-world-machine-learning-problems/](https://machinelearningmastery.com/tour-of-real-world-machine-learning-problems/)

现实世界的例子使机器学习的抽象描述变得具体。

在这篇文章中，您将继续了解真实世界的机器学习问题。您将看到机器学习如何在教育，科学，技术和医学等领域实际应用。

列出的每个机器学习问题还包括指向公开数据集的链接。这意味着如果您对特定的具体机器学习问题感兴趣，您可以下载数据集并立即开始练习。

![Real World Machine Learning](img/c0bb9b5be856b133acbcbd5fe237dc64.jpg)

真实世界机器学习
照片由 [SMI 眼动追踪](https://www.flickr.com/photos/smieyetracking/5546677366/)保留一些权利。

## 最受欢迎的 Kaggle 数据集

前 10 个机器学习问题的例子来自竞争机器学习网站 [Kaggle.com](https://www.kaggle.com/) 。受欢迎程度取决于参赛队伍的数量。

*   [奥托集团产品分类挑战赛](https://www.kaggle.com/c/otto-group-product-classification-challenge)。鉴于产品数据的特征，将产品分类为 9 个产品类别之一。
*   [Rossmann 商店销售](https://www.kaggle.com/c/rossmann-store-sales)。根据商店的产品历史销售数据，预测未来的销售情况。
*   [自行车共享需求](https://www.kaggle.com/c/bike-sharing-demand)。鉴于每日自行车租赁和天气记录预测未来每日自行车租赁需求。
*   [Analytics Edge](https://www.kaggle.com/c/15-071x-the-analytics-edge-competition-spring-2015) 。鉴于新时代的细节，文章预测哪些新闻纸文章会受欢迎。
*   [餐厅收入预测](https://www.kaggle.com/c/restaurant-revenue-prediction)。鉴于餐厅网站的详细信息预测了特定年份餐厅的收入。
*   [Liberty Mutual Group：物业检查预测](https://www.kaggle.com/c/liberty-mutual-group-property-inspection-prediction)。鉴于检查属性的详细信息预测了属性的危险评分。
*   [Springleaf 营销响应](https://www.kaggle.com/c/springleaf-marketing-response)。鉴于客户的特征预测他们是否是营销目标。
*   [希格斯玻色子机器学习挑战](https://www.kaggle.com/c/higgs-boson)。鉴于模拟粒子碰撞的描述预测事件是否衰变为希格斯玻色子。
*   [森林覆盖类型预测](https://www.kaggle.com/c/forest-cover-type-prediction)。鉴于制图变量预测森林覆盖类型。
*   [Amazon.com 员工访问挑战](https://www.kaggle.com/c/amazon-employee-access-challenge)。鉴于员工的历史资源访问权限变化可预测员工所需的资源。

## 最受欢迎的研究数据集

接下来的 10 个机器学习问题是[加州大学 Irvine 机器学习库](http://archive.ics.uci.edu/ml/)网站上最受欢迎的，该网站传统上托管机器学习研究社区使用的机器学习数据集。

*   [虹膜数据集](http://archive.ics.uci.edu/ml/datasets/Iris)。鉴于以厘米为单位的花测量预测虹膜的种类。
*   [成人数据集](http://archive.ics.uci.edu/ml/datasets/Adult)。鉴于人口普查数据预测个人每年将获得超过 50,000 美元的收入。
*   [葡萄酒数据集](http://archive.ics.uci.edu/ml/datasets/Wine)。鉴于葡萄酒的化学分析预测了风的起源。
*   [汽车评估数据集](http://archive.ics.uci.edu/ml/datasets/Car+Evaluation)。鉴于汽车的详细信息预测了汽车的估计安全性。
*   [乳腺癌威斯康星数据集](http://archive.ics.uci.edu/ml/datasets/Breast+Cancer+Wisconsin+%28Diagnostic%29)。鉴于对乳房组织进行诊断测试的结果，预测肿块是否是肿瘤。
*   [鲍鱼数据集](http://archive.ics.uci.edu/ml/datasets/Abalone)。鉴于鲍鱼的测量值预测了鲍鱼的年龄。
*   [葡萄酒质量数据集](http://archive.ics.uci.edu/ml/datasets/Wine+Quality)。鉴于葡萄酒的各种测量值可以预测葡萄酒的质量。
*   [心脏病数据集](http://archive.ics.uci.edu/ml/datasets/Heart+Disease)。鉴于对患者的各种诊断测试的结果预测患者的心脏病量。
*   [Poker Hand 数据集](http://archive.ics.uci.edu/ml/datasets/Poker+Hand)。给定扑克手的数据库预测手的质量。
*   [使用智能手机数据集识别人类活动](http://archive.ics.uci.edu/ml/datasets/Human+Activity+Recognition+Using+Smartphones)。从智能手机移动数据预测持有智能手机的人所执行的活动的类型。
*   [森林火灾数据集](http://archive.ics.uci.edu/ml/datasets/Forest+Fires)。鉴于气象和其他因素预测了森林火灾的烧毁面积。
*   [互联网广告数据集](http://archive.ics.uci.edu/ml/datasets/Internet+Advertisements)。鉴于网页上图像的细节预测图像是否是广告。

## 最后的世界

我们对 20 个真实世界的机器学习问题进行了旋风式的考察。

这些是世界各地的科学和商业组织提出或调查的实际问题。

更令人兴奋的是，这些不同的问题具有公开可用的数据集，并且也被广泛研究和理解。

这意味着您可以立即下载数据并通过实施自己的模型来探索问题，或者从纸质或博客文章中重现其他人的问题。