# 如果我没有学位怎么办？

> 原文： [https://machinelearningmastery.com/what-if-i-dont-have-a-degree/](https://machinelearningmastery.com/what-if-i-dont-have-a-degree/)

我见过有人认为他们需要获得机器学习学位。

我都是学位，我不认为他们适合所有人。我也知道你可以开始学习机器学习并且没有学位就能走得更远。

在这篇文章中，我将说服你，你不需要获得机器学习的学位就可以开始或在机器学习领域取得进步。

[![What if I Don't Have a Degree](img/132b6866cca2360525bbc9773c1ce7fe.jpg)](https://3qeqpr26caki16dnhd19sv6by6v-wpengine.netdna-ssl.com/wp-content/uploads/2014/01/What-if-I-Dont-Have-a-Degree.jpg)

如果我没有学位怎么办
照 [Alexander Kachkaev](http://www.flickr.com/photos/kachkaev/8409381914/sizes/l/) ，保留一些权利

## 机器学习学位

您可能认为您需要机器学习学位，也许您需要。

您认为需要学位的部分原因是：

*   **正确学习机器学习**。获得机器学习学位将以结构化的方式教您机器学习。学位课程由具有相关主题和如何教育经验的学者设计。学位课程的目标是明确定义学生在加入课程之前的期望以及学生在课程结束后的能力。
*   **找工作**。获得更高的机器学习学位将使您有机会申请机器学习工作。组织广告需要特定技能的工作，并选择允许他们有效过滤申请人的先决条件。机器学习工作的广告通常需要一定程度或更高程度的机器学习或密切相关的领域。
*   **练习机器学习研究**。获得更高的机器学习学位将使您有机会进行机器学习研究。绝大多数机器学习研究由大学和工业研究实验室制作。这些实验室的竞争非常激烈，广告职位的先决条件是具体的本科学位和荣誉课程。

## 学位有限制

如果你能完成机器学习的学位，它并不能保证你所寻求的结果。它可能会增加你的机会，但不能保证成功。学位很棒，我自己也有一些，但请记住，他们只是一条路，就像任何路径都有自己的一套限制。

接受并完成正式学位是一项艰巨的任务。下面列出了一些帮助您深入考虑这种方法的要点。

*   **学位很贵**。学位课程可能花费数万美元或更多，而你正在牺牲你在那段时间可能获得的任何收入，希望你将来有更大的收入潜力。当然，您可以通过奖学金抵消这些费用，并且您可以将这些费用推迟到未来。
*   **学位是其他人的标志**。有声望获得学位，尤其是更高学位。完成学位是其他人评价你的象征。它是雇主用来使招聘过程更有效的过滤器。
*   **学位需要很长时间**。学位需要数年，更高的学位可能需要很多年，甚至是十年中最好的部分。如果您今天有兴趣申请或使用机器学习，那么等待很长时间。
*   **学位是针对普通学生**。学位由一个委员会为普通学生设计，具有平均表现和先决条件。它没有考虑您的特定兴趣或技能。
*   **学位教师的旧信息**。在购买程序访问权限之前设计学位。在本科阶段，这可能意味着材料至少过时了许多年。

## 略读学位

你能否跳过学位并仍然有机会得到你想要的东西？我认为你可以并且有多种途径可供你使用。

例如，我正在实施机器学习算法，撰写有关 AI 的文章，并在作为程序员全职工作的同时赢得与会议相关的竞赛。 Kaggle（一个机器学习比赛网站）的一些评分最高的竞争对手没有更高的学位，如果他们这样做，他们在完全不同的学习领域。

### 正确学习机器学习

您可以按照自己的步调在家中完成机器学习的正式训练。正式训练方案的三种选择包括：

*   完成机器学习在线课程。观看讲座，做作业并与其他学生互动。
*   阅读一本关于机器学习的书，涵盖了封面。做笔记，完成练习，并实施您学到的知识。
*   设计并执行自己的课程。利用您最感兴趣的主题的高质量免费和付费材料，设计课程并添加您需要的手续。

### 找个工作

您可以创建符号，向潜在雇主表明您擅长机器学习。它将需要您的主动性和营销。您可以创建三个符号示例：

*   完成课程或阅读书籍，并随时在公共博客中跟踪您的进度和发现。
*   参加机器学习竞赛并努力获得适度的排名，例如在竞赛中排名前 n％。与熟练的从业者合作，更快地获得技能并获得更好的结果。
*   完成机器学习中的小项目，在博客和社交媒体上宣传结果，并在公共修订控制系统上发布代码。建立一系列已完成的项目，您可以参考，借鉴和讨论。

### 实践机器学习研究

如果您沉迷于特定的概念或机器学习方法，您可以设计自己的研究计划。

更高的学位实际上是研究和研究方法的学徒，以及对该领域更深层次的归纳，并且难以独立复制。

然而，如果你可以在机构之外练习机器学习研究。三个例子包括：

*   **从应用研究论文**中重现结果。这可能需要与相关研究人员进行沟通，以了解方法和数据的细节。结果的再现是科学方法和示范的支柱，结果可以或不可以再现，这本身就是可发表的研究。您可以首先将您的经历写博客并将您的发现推广给感兴趣的研究人员。
*   **在您的主题上自行发布您自己的治疗**。这可能是白皮书，散文或电子书专着的形式。尽你最大的努力，并有信心与研究界联系以征求意见和评论。
*   **通过推出出色的作品并表现出对其他作品的兴趣来进行贡献和合作**。与该领域的研究人员建立并保持联系。像任何关系一样，开始慢，建立信任。

任何人都可以阅读和内化研究论文，写下他们自己的想法和设计并执行他们自己的实验。从小做起，说实话。学者们喜欢在一切事物中挑洞，品味并从任何形式的反馈中学习。

不要让你认为学位需要阻止你开始进行机器学习或者认为你可以取得重大进展。

## 摘要

在这篇文章中，您了解到您可以从机器学习领域开始，并在没有学位或更高学位的情况下取得您所寻求的进步。

您了解到有多条路径可用，而学位只是一条可以消耗大量时间和资源的路径。您还学习了学位的结构化学习和高等学位课程的研究学徒的替代方法。

正规教育是一个有争议的问题，我很想听听你对这篇文章的看法。请发表评论，让我知道你的想法。