# 机器学习适合哪里？

> 原文： [https://machinelearningmastery.com/where-does-machine-learning-fit-in/](https://machinelearningmastery.com/where-does-machine-learning-fit-in/)

机器学习是一个多学科领域，当您开始将机器学习与人工智能和数据挖掘这些密切相关的领域区分开来时，它可能会非常混乱。

在这篇文章中，您将了解与机器学习相关的那些领域。具体来说，您将通过学习机器学习如何建立在数学和人工智能领域并在数据挖掘和数据科学等领域中使用来了解该领域的边界。

## 基金会

机器学习建立在数学和计算机科学领域。具体而言，机器学习方法最好使用线性和矩阵代数来描述，并且使用概率和统计工具可以最好地理解它们的行为。统计学，概率论和人工智能领域，代表机器学习的基础科目。

### 可能性

概率论领域是研究随机事件可能性的特征。概率论是数学的一个分支，为统计学领域提供了基础。

[![probability](img/88efae28e2604ffab863bc5cd691ad1f.jpg)](https://3qeqpr26caki16dnhd19sv6by6v-wpengine.netdna-ssl.com/wp-content/uploads/2013/12/dice.jpg)

照片归功于 [topher76](http://www.flickr.com/photos/topher76/293277608/sizes/l/) ，保留一些权利。

机器学习方法通​​常用概率语言描述，有些方法直接采用概率理论，如[贝叶斯定理](http://en.wikipedia.org/wiki/Bayes'_theorem)。

### 统计

统计领域是研究收集，分析，描述和呈现数据的方法。统计学是数学的一个分支。该领域关注的问题是数据的含义。

在统计框架中可以很好地理解机器学习，其中从训练数据中学习作为数据中结构和关系的建模。因此，机器学习中采用统计建模方法，但机器学习不仅包括统计建模方法。

### 人工智能

人工智能领域是研究和构建计算系统，它们可以完成人类可以做的事情，也可以做我们认为聪明的事情。例如，人类可以在环境中移动，了解他们所看到的内容并理解他们所阅读和听到的语言，并且我们拥有相应的机器人，计算机视觉和自然语言处理子领域。大师级国际象棋冠军被认为是智能的，因此创造了国际象棋智能系统。人工智能是计算机科学的一个分支。该领域关注什么是情报以及如何创造情报的问题。

学习是智能系统的一个特征。因此，机器学习被认为是人工智能的一个分支，涉及研究和构建能够学习的系统。

## 前体细胞

可以从数据中学习来描述数据并预测未见数据结果的算法对于解决复杂问题非常有用。因此，机器学习方法用于应用计算机科学领域，例如数据挖掘和数据科学。此外，还有相关的人工智能领域，研究智能方法，这些方法也可以从数据及其环境中学习。例子包括计算智能和 Mateheuristics。

让我们回顾一下计算智能，数据挖掘和数据科学的相关领域，并学习如何应用机器学习方法。

### 计算智能

[计算智能](http://en.wikipedia.org/wiki/Computational_Intelligence)的领域涉及易于指定但导致复杂的紧急行为的系统的研究和构建。许多计算智能系统受到自然系统的启发，例如进化，免疫系统和子进程的神经系统，如进化计算，人工免疫系统和人工神经网络。计算智能是人工智能的一个分支。该领域关注的是解释复杂的紧急行为如何从简单的规则中得出以及它们最适合解决的问题。

许多计算智能系统从与其环境的交互中学习，因此已被用作机器学习方法。

### 数据挖掘

数据挖掘领域是研究和构建从大型数据集中发现有趣关系的系统。因此，数据挖掘既包括数据的存储和维护，也包括在数据中进行发现的过程。数据挖掘是一个过程，在数据库（KDD）中也称为[知识发现。数据挖掘是计算机科学的一个子领域。该领域关注的是哪些关系是有趣的以及如何最好地发现它们的问题。](http://en.wikipedia.org/wiki/Data_mining)

机器学习提供了一组在数据挖掘过程中使用的工具，用于学习提供发现基础的数据关系。

### 数据科学

[数据科学](http://en.wikipedia.org/wiki/Data_science)的领域涉及使用数据解决复杂问题的实用性。数据科学是计算机科学的一个子领域。数据科学是数据挖掘过程的应用和机器学习方法在特定领域的使用。数据科学家是数据科学的实践者。

与数据挖掘一样，机器学习提供了一组用于数据科学的工具，用于学习数据中的关系，以便表征数据或进行预测。

机器学习与其他数学领域（如决策理论和信息理论）和计算机科学（如运筹学和凸优化）有关。

## 资源

如果您想深入挖掘一下，我会链接到一些论文和书籍。

*   Leo Breiman，[统计模型：两种文化](http://scholar.google.com/scholar?q=Statistical+Modeling+The+Two+Cultures)，2001
*   Stuart Russell 和 Peter Norvig，[人工智能：现代方法（第 3 版）](http://www.amazon.com/dp/0136042597?tag=inspiredalgor-20)（会员链接），2009
*   Andries Engelbrecht，[计算智能：简介](http://www.amazon.com/dp/0470035617?tag=inspiredalgor-20)（会员链接），2007

您认为机器学习与其他领域密切相关吗？您对所描述的其中一个领域有更清晰的定义吗？发表评论。