# 为什么要进入机器学习？

> 原文： [https://machinelearningmastery.com/why-get-into-machine-learning/](https://machinelearningmastery.com/why-get-into-machine-learning/)

## _ 发现你的个人原因和 _
_ 终于搞砸 _

在这篇文章中，我们将探讨您对机器学习感兴趣的原因。

我们将看一些可以帮助您了解吸引您到现场的根本问题。

我们将完成一个显示 4 个主要“_ 为什么 _”的地图，以便您确定适合的位置和目标资源。

## 问你的原因

你为什么对机器学习感兴趣？你有没有深入考虑过这个问题？

了解原因很有用，因为您可以将其用作过滤器，以便最好地选择您喜欢的项目和任务。如果你不能明白为什么，那也可能有用，因为它可以激励你尝试一堆不同的东西，找出你喜欢或想做的事情。

出于很多原因，您可能会被机器学习所吸引。也许您正在回应有关大数据和数据科学的媒体和新闻文章。也许你已经看到了工具或朋友的机器学习的一瞥，你认为它很酷。可能有很多原因，但学习机器学习是一项艰苦的工作。要有信心和坚持不懈地研究困难和令人沮丧的部分，你会想要有一个强大的原因可以依靠。

我将提出一些修辞问题，我希望你能够思考（甚至写下）你的答案，看看哪一个最适合你。一个问题并不比另一个更好 - 保持开放的心态。

## 您希望机器学习为您做什么？

### 解决问题

你有一个问题，你认为机器学习可以解决？

也许这是一个开放的业务问题或工作中的问题。也许这是你在市场上看到的机会。然而，您正在考虑将机器学习作为学习和应用于问题的工具。

在这种情况下，您可能有兴趣学习提供可以快速使用的算法实现的工具。您也很可能对使用这些工具的创造性方法感兴趣，例如对您想要解决的问题等问题进行案例研究。

### 技术成就

学习机器学习是成就的标志吗？

也许机器学习是一个受欢迎的技术领域，你会因为学习新的和困难的技术和工具而感到非常自豪。也许您将机器学习视为您的下一个重大挑战和增长机会，并有机会展示您学习和掌握技术材料的能力。

如果这听起来像你，你可能会对算法书感兴趣，你可以快速跟踪对方法的理解以及如何使用它而无需深入研究最新的研究。您也很可能有兴趣自己完成课程，参加比赛和实施算法。

## 你想用机器学习做什么？

### 扩展领域

您是否已经拥有一些机器学习经验，并希望扩展可能的范围？

也许你已经在机器学习，读书或完成课程。你找到了一个你不能放下的问题或方法，你不仅想要深入研究这种方法，而且你想要突破那种方法可以做的事情，并且已经证明能够做到这一点。 。

如果这敲响了钟声，您可能会对该主题的深层主题感兴趣，例如研究论文和专着。您可能也非常有兴趣听取有关该主题的专家意见以及边界边缘的确切位置。

### 做以前不可能做的事

您有一些机器学习的经验，并且您拥有一些领域专业知识，并且您希望在您的域中执行在没有机器学习的情况下无法实现的事情。这些不一定是上面“解决问题”部分中提到的那些问题，而是使用机器学习提供的经验和功能扩展域。

您将对从数据挖掘到模式自动发现的方法感兴趣。您也很可能对类似领域中机器学习方法所做的发现和扩展的案例研究感兴趣。

## 机器学习地图

这完全是对该领域的简化，但我们可以根据我们想要做的工作类型来分类学习机器学习的动机。我们可以将我们想要做的工作类型分类为解决机器学习或其他领域的问题。您可以将任务类型分类为从业者的任务和研究人员的任务。

我试图在表格中捕获此摘要，请参阅下文。

该表按域分为两行：_ 机器学习 _ 和 _ 其他 _ 域的域（如分析化学，石油开采或运输分析）。该表按角色分为两列：_ 从业者 _ 和 _ 研究员 _。每个框都有该域 - 角色交集的任务类型，_ 解决问题 _ 或 _ 扩展字段 _。表格中的每个单元格列出了对该任务感兴趣的人可能感兴趣的资源类型。

[![Why get into machine learning](img/7d8913d78150b9b47a058d58b5487c44.jpg)](https://3qeqpr26caki16dnhd19sv6by6v-wpengine.netdna-ssl.com/wp-content/uploads/2013/11/Why-get-into-machine-learning.png)

地图显示了进入机器学习的 4 个原因。

每个单元格都可以被认为是激励您更多地了解机器学习的原因，而资源列表可以帮助您实现这一目标。

这只是削减馅饼的一种方式，但我已经冥想了几个星期了。我在分组上努力工作，我很想知道你对它的看法，请发表评论。我很想让一些专业人士开始挖洞，这样我们就可以看到这个模型的优点和局限性（所有模型都是错误的，只是程度问题）。

请发表评论，让我知道您的原因在哪里以及您认同的内容。

我要感谢我的妻子帮助我思考并将其全部映射到白板上。